Package com.smartgwt.client.widgets.menu

# Class Menu

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.layout.Layout
com.smartgwt.client.widgets.layout.VLayout
com.smartgwt.client.widgets.grid.ListGrid
com.smartgwt.client.widgets.menu.Menu

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `DataBoundComponent`, `HasClearHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragCompleteHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropCompleteHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFetchDataHandlers`, `HasFocusChangedHandlers`, `HasFormulaUpdatedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`, `HasBodyKeyPressHandlers`, `HasCellClickHandlers`, `HasCellContextClickHandlers`, `HasCellDoubleClickHandlers`, `HasCellErrorIconHoverHandlers`, `HasCellErrorIconOutHandlers`, `HasCellErrorIconOverHandlers`, `HasCellHoverHandlers`, `HasCellMouseDownHandlers`, `HasCellMouseUpHandlers`, `HasCellOutHandlers`, `HasCellOverHandlers`, `HasCellSavedHandlers`, `HasCellSelectionChangedHandlers`, `HasCellValueHoverHandlers`, `HasCriteriaChangedHandlers`, `HasDataArrivedHandlers`, `HasDataChangedHandlers`, `HasDrawAreaChangedHandlers`, `HasEditCompleteHandlers`, `HasEditFailedHandlers`, `HasEditorEnterHandlers`, `HasEditorExitHandlers`, `HasFieldStateChangedHandlers`, `HasFilterEditorSubmitHandlers`, `HasGroupByCompleteHandlers`, `HasGroupByHandlers`, `HasGroupStateChangedHandlers`, `HasGroupTreeChangedHandlers`, `HasHeaderClickHandlers`, `HasHeaderDoubleClickHandlers`, `HasHeaderHoverHandlers`, `HasHilitesChangedHandlers`, `HasRecordClickHandlers`, `HasRecordCollapseHandlers`, `HasRecordDoubleClickHandlers`, `HasRecordDropHandlers`, `HasRecordExpandHandlers`, `HasRegroupHandlers`, `HasRemoveRecordClickHandlers`, `HasRowContextClickHandlers`, `HasRowEditorEnterHandlers`, `HasRowEditorExitHandlers`, `HasRowHoverHandlers`, `HasRowMouseDownHandlers`, `HasRowMouseUpHandlers`, `HasRowOutHandlers`, `HasRowOverHandlers`, `HasSelectionChangedHandlers`, `HasSelectionUpdatedHandlers`, `HasSetSortHandlers`, `HasSortChangedHandlers`, `HasSorterClickHandlers`, `HasSorterContextClickHandlers`, `HasViewStateChangedHandlers`, `HasMembersChangedHandlers`, `HasItemClickHandlers`

Direct Known Subclasses:
  `MenuPalette`, `SelectionTreeMenu`

public class Menu extends ListGrid implements HasItemClickHandlers
The Menu widget class implements interactive menu widgets, with optional icons, submenus, and shortcut keys.

A Menu is initialized with a set of `MenuItem`s specified as `items`, each of which represents one row in the menu's display and specifies the action to take when that menu item is selected.

Each `MenuItem` can have a `title`, `icon`, `shortcut keys`, optional `MenuItem.submenu` and various other settings. Alternatively, a `MenuItem` can contain an arbitrary widget via `MenuItem.embeddedComponent`.

To create a context menu for a component, provide a Menu instance for the `Canvas.contextMenu` property. Note that some components like `ListGrid` have more specific properties because they have distinct regions or because they have a default set of context menu actions available (for example: `ListGrid.headerContextMenu` and related APIs).

If you want a button that pops up a menu when clicked, or a bar of such buttons, see the `MenuButton` and `MenuBar` classes.

To create a pop-up panel interface that looks nothing like a `Menu` (but still dismisses automatically on an outside click), use `Canvas.showClickMask()` to arrange for automatic dismissal, and the `Canvas.showNextTo()` utility method to place the component near whatever triggered it, while automatically staying on-screen.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final ListGridField`
  `ICON_FIELD`
  `static final ListGridField`
  `KEY_FIELD`
  `static final ListGridField`
  `SUBMENU_FIELD`
  `static final ListGridField`
  `TITLE_FIELD`

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Menu()`
  `Menu(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addItem(MenuItem item)`
  `void`
  `addItem(MenuItem item, int index)`
  `HandlerRegistration`
  `addItemClickHandler(ItemClickHandler handler)`
  Add a itemClick handler.
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `protected JavaScriptObject`
  `create()`
  `void`
  `fetchData()`
  This DataBoundComponent method does not apply to Menu.
  `void`
  `fetchData(Criteria criteria)`
  See `fetchData()`
  `void`
  `fetchData(Criteria criteria, DSCallback callback)`
  See `fetchData()`
  `void`
  `fetchData(Criteria criteria, DSCallback callback, DSRequest requestProperties)`
  This DataBoundComponent method does not apply to Menu.
  `MenuItem[]`
  `getAllItems()`
  Retrieves the full set of items for this menu, including `hidden items`
  `Boolean`
  `getAlternateRecordStyles()`
  Explicitly disable alternateRecordStyles at the menu level by default so setting to true for all ListGrids will not impact menus' appearance.
  `Boolean`
  `getAutoDismiss()`
  When false, when a menu item is chosen (via mouse click or keyboard), the menu is not automatically hidden, staying in place for further interactivity
  `Boolean`
  `getAutoDismissOnBlur()`
  When false, when a user clicks outside the menu, or hits the Escape key, this menu will not be automatically hidden, staying in place for further interactivity.
  `Boolean`
  `getAutoDraw()`
  Menus will not draw on initialization, until they're explicitly show()n
  `String`
  `getBaseStyle()`
  CSS style for a normal cell
  `String`
  `getBodyStyleName()`
  CSS style used for the body of this menu when there is no icon field.
  `String`
  `getCancelButtonTitle()`
  Title for the "Done" button shown when the `NavigationBar` is present.
  `boolean`
  `getCanSaveSearches()`
  Option to save searches is disabled for menus
  `Boolean`
  `getCanSelectParentItems()`
  If true, clicking or pressing Enter on a menu item that has a submenu will select that item (with standard behavior of hiding the menus, calling click handlers, etc) instead of showing the submenu.
  `boolean`
  `getCanShowFilterEditor()`
  Option to show filter editor is disabled for menus
  `Boolean`
  `getCascadeAutoDismiss()`
  When true any generated submenus will inherit `autoDismiss` from this menu.
  `int`
  `getCellHeight()`
  The height of each item in the menu, in pixels.
  `String`
  `getCellStyle(ListGridRecord record, int rowNum, int colNum)`
  Return the CSS class for a cell.
  `String`
  `getCheckmarkDisabledImage()`
  Default image to display for `check-marked items` when the item is disabled.
  `ImgHTMLProperties`
  `getCheckmarkDisabledImageAsImgHTMLProperties()`
  Default image to display for `check-marked items` when the item is disabled.
  `String`
  `getCheckmarkImage()`
  Default image to display for `check-marked items`.
  `ImgHTMLProperties`
  `getCheckmarkImageAsImgHTMLProperties()`
  Default image to display for `check-marked items`.
  `DataSource`
  `getDataSource()`
  Optional DataSource to fetch menuItems and submenus from, instead of using `items`.
  `String`
  `getDataSourceAsString()`
  Optional DataSource to fetch menuItems and submenus from, instead of using `items`.
  `int`
  `getDefaultWidth()`
  The default menu width.
  `String`
  `getEditProxyConstructor()`
  Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
  `String`
  `getEmptyMessage()`
  Message to show when a menu is shown with no items.
  `Boolean`
  `getFetchSubmenus()`
  When using a Tree or hierarchical DataSource as the menu's data, submenus are automatically generated from child nodes.
  `String`
  `getFillSpaceStyleName()`
  If set, alternative body style for the menu used when there is no icon field and the `placement` settings indicate the menu will be filling a portion of the screen or a panel.
  `Boolean`
  `getFilterHiddenItems()`
  Does this hide menu items marked as `hidden menu items` by filtering them out of the data set?
  `String`
  `getIconBodyStyleName()`
  If set, the CSS style used for the body of this menu when there is an icon field.
  `static ListGridField`
  `getIconFieldDefaults()`
  Default properties for the automatically generated icon column.
  `ListGridField`
  `getIconFieldProperties()`
  Custom properties for the automatically generated icon column.
  `String`
  `getIconFillSpaceStyleName()`
  If set, alternative body style for the menu used when there is an icon field and the `placement` settings indicate the menu will be filling a portion of the screen or a panel.
  `int`
  `getIconHeight()`
  The default height applied to custom icons in this menu.
  `int`
  `getIconWidth()`
  The default width applied to custom icons in this menu.
  `Criteria`
  `getInitialCriteria()`
  Criteria to be used when fetching items for this Menu.
  `MenuItem`
  `getItem(int item)`
  Get a particular MenuItem by index.
  `MenuItem`
  `getItem(int item, boolean logicalIndex)`
  Get a particular MenuItem by index.
  `String`
  `getItemHiddenProperty()`
  Items with this property set to true will be hidden within the menu.
  `int`
  `getItemNum(MenuItem item)`
  Given a MenuItem, return it's index in the items array.
  `MenuItem[]`
  `getItems()`
  Return the menu items.
  `static ListGridField`
  `getKeyFieldDefaults()`
  Default properties for the automatically generated key column.
  `ListGridField`
  `getKeyFieldProperties()`
  Custom properties for the automatically generated key column.
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `Integer`
  `getMenuButtonWidth()`
  For a menu that has a `MenuButton` generated for it automatically (for example when included in a `MenuBar`, the width that the MenuButton should have.
  `NavigationBar`
  `getNavigationBar()`
  Navigation bar shown when `placement` setting indicates that the menu should be shown filling a portion of the screen or a panel.
  `Canvas`
  `getNavStack()`
  When the `placement` setting indicates that the menu should be shown filling a portion of the screen or a panel, `navStack` is a container element created to hold the `NavigationBar` and any submenus that are shown by the menu.
  `JavaScriptObject`
  `getOrCreateJsObj()`
  `static Menu`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `static Menu`
  `getOrCreateRef(JavaScriptObject jsObj, MenuItem parentItem)`
  `PanelPlacement`
  `getPlacement()`
  Where should the menu be placed on the screen?
  `String`
  `getShowAnimationEffect()`
  When this menu is shown how should it animate into view? By default the menu will just show at the specified size/position.
  `Boolean`
  `getShowEdges()`
  `showEdges` dynamically defaults to false when the `placement` setting indicates the Menu will be filling a portion of the screen or a panel.
  `Boolean`
  `getShowIcons()`
  A boolean, indicating whether the checkmark/custom icon column should be displayed.
  `Boolean`
  `getShowKeys()`
  A boolean, indicating whether the shortcut key column should be displayed.
  `Boolean`
  `getShowShadow()`
  Whether to show a drop shadow for this Canvas.
  `Boolean`
  `getShowSubmenus()`
  A boolean, indicating whether the submenu indicator column should be displayed.
  `Menu`
  `getSubmenu(MenuItem item)`
  Creates and returns the submenu associated with the provided MenuItem.
  `String`
  `getSubmenuConstructor()`
  When using a Tree or hierarchical DataSource as the menu's data, optional subclass of Menu that should be used when generating submenus.
  `String`
  `getSubmenuDirection()`
  Should submenus show up on our left or right.
  `String`
  `getSubmenuDisabledImage()`
  Default image to use for the submenu indicator when the item is disabled.
  `ImgHTMLProperties`
  `getSubmenuDisabledImageAsImgHTMLProperties()`
  Default image to use for the submenu indicator when the item is disabled.
  `static ListGridField`
  `getSubmenuFieldDefaults()`
  Default properties for the automatically generated submenu column.
  `ListGridField`
  `getSubmenuFieldProperties()`
  Custom properties for the automatically generated submenu column.
  `String`
  `getSubmenuImage()`
  Default image to use for the submenu indicator.
  `ImgHTMLProperties`
  `getSubmenuImageAsImgHTMLProperties()`
  Default image to use for the submenu indicator.
  `Canvas`
  `getTarget()`
  Optional target canvas for this menu.
  `protected Menu`
  `getTestInstance()`
  `static ListGridField`
  `getTitleFieldDefaults()`
  Default properties for the automatically generated title column.
  `ListGridField`
  `getTitleFieldProperties()`
  Custom properties for the automatically generated title column.
  `Boolean`
  `getUseKeys()`
  A boolean indicating whether this menu should use shortcut keys.
  `int`
  `getVisibleItemNum(MenuItem item)`
  Given a MenuItem, return its index in the currently visible set of items.
  `static void`
  `hideAllMenus()`
  Hide all menus that are currently open.
  `void`
  `hideContextMenu()`
  Hide the context menu - alias for hide()
  `protected void`
  `onInit_ListGrid()`
  `void`
  `relinkJavaScriptObject(JavaScriptObject jsObj)`
  `void`
  `removeItem(MenuItem item)`
  `Menu`
  `setAlternateRecordStyles(Boolean alternateRecordStyles)`
  Explicitly disable alternateRecordStyles at the menu level by default so setting to true for all ListGrids will not impact menus' appearance.
  `Menu`
  `setAutoDismiss(Boolean autoDismiss)`
  When false, when a menu item is chosen (via mouse click or keyboard), the menu is not automatically hidden, staying in place for further interactivity
  `Menu`
  `setAutoDismissOnBlur(Boolean autoDismissOnBlur)`
  When false, when a user clicks outside the menu, or hits the Escape key, this menu will not be automatically hidden, staying in place for further interactivity.
  `Menu`
  `setAutoDraw(Boolean autoDraw)`
  Menus will not draw on initialization, until they're explicitly show()n
  `Menu`
  `setBaseStyle(String baseStyle)`
  CSS style for a normal cell
  `Menu`
  `setBodyStyleName(String bodyStyleName)`
  CSS style used for the body of this menu when there is no icon field.
  `Menu`
  `setCancelButtonTitle(String cancelButtonTitle)`
  Title for the "Done" button shown when the `NavigationBar` is present.
  `Menu`
  `setCanSaveSearches(boolean canSaveSearches)`
  Option to save searches is disabled for menus
  `Menu`
  `setCanSelectParentItems(Boolean canSelectParentItems)`
  If true, clicking or pressing Enter on a menu item that has a submenu will select that item (with standard behavior of hiding the menus, calling click handlers, etc) instead of showing the submenu.
  `Menu`
  `setCanShowFilterEditor(boolean canShowFilterEditor)`
  Option to show filter editor is disabled for menus
  `Menu`
  `setCascadeAutoDismiss(Boolean cascadeAutoDismiss)`
  When true any generated submenus will inherit `autoDismiss` from this menu.
  `Menu`
  `setCellHeight(int cellHeight)`
  The height of each item in the menu, in pixels.
  `Menu`
  `setCheckmarkDisabledImage(ImgHTMLProperties checkmarkDisabledImage)`
  Default image to display for `check-marked items` when the item is disabled.
  `Menu`
  `setCheckmarkDisabledImage(String checkmarkDisabledImage)`
  Default image to display for `check-marked items` when the item is disabled.
  `Menu`
  `setCheckmarkImage(ImgHTMLProperties checkmarkImage)`
  Default image to display for `check-marked items`.
  `Menu`
  `setCheckmarkImage(String checkmarkImage)`
  Default image to display for `check-marked items`.
  `void`
  `setConfig(JavaScriptObject config)`
  `void`
  `setCriteria(AdvancedCriteria criteria)`
  This DataBoundComponent method is not supported - use `initialCriteria` to apply criteria to the fetches made by menus.
  `void`
  `setCriteria(Criteria criteria)`
  This DataBoundComponent method is not supported - use `initialCriteria` to apply criteria to the fetches made by menus.
  `Menu`
  `setData(Record... data)`
  An array of menuItem objects, specifying the menu items this menu should show.
  `Menu`
  `setData(RecordList data)`
  An array of menuItem objects, specifying the menu items this menu should show.
  `Menu`
  `setData(MenuItem... data)`
  An array of menuItem objects, specifying the menu items this menu should show.
  `Menu`
  `setData(Tree data)`
  An array of menuItem objects, specifying the menu items this menu should show.
  `void`
  `setDataProperties(Tree dataProperties)`
  For a `Menu` that uses a DataSource, these properties will be passed to the automatically-created ResultTree.
  `Menu`
  `setDataSource(DataSource dataSource)`
  Optional DataSource to fetch menuItems and submenus from, instead of using `items`.
  `Menu`
  `setDataSource(String dataSource)`
  Optional DataSource to fetch menuItems and submenus from, instead of using `items`.
  `static void`
  `setDefaultProperties(Menu menuProperties)`
  Class level method to set the default properties of this class.
  `Menu`
  `setDefaultWidth(int defaultWidth)`
  The default menu width.
  `Menu`
  `setEditProxyConstructor(String editProxyConstructor)`
  Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
  `Menu`
  `setEmptyMessage(String emptyMessage)`
  Message to show when a menu is shown with no items.
  `Menu`
  `setFetchSubmenus(Boolean fetchSubmenus)`
  When using a Tree or hierarchical DataSource as the menu's data, submenus are automatically generated from child nodes.
  `Menu`
  `setFillSpaceStyleName(String fillSpaceStyleName)`
  If set, alternative body style for the menu used when there is no icon field and the `placement` settings indicate the menu will be filling a portion of the screen or a panel.
  `Menu`
  `setFilterHiddenItems(Boolean filterHiddenItems)`
  Does this hide menu items marked as `hidden menu items` by filtering them out of the data set?
  `Menu`
  `setIconBodyStyleName(String iconBodyStyleName)`
  If set, the CSS style used for the body of this menu when there is an icon field.
  `static void`
  `setIconFieldDefaults(ListGridField iconFieldDefaults)`
  Default properties for the automatically generated icon column.
  `Menu`
  `setIconFieldProperties(ListGridField iconFieldProperties)`
  Custom properties for the automatically generated icon column.
  `Menu`
  `setIconFillSpaceStyleName(String iconFillSpaceStyleName)`
  If set, alternative body style for the menu used when there is an icon field and the `placement` settings indicate the menu will be filling a portion of the screen or a panel.
  `Menu`
  `setIconHeight(int iconHeight)`
  The default height applied to custom icons in this menu.
  `Menu`
  `setIconWidth(int iconWidth)`
  The default width applied to custom icons in this menu.
  `Menu`
  `setInitialCriteria(Criteria initialCriteria)`
  Criteria to be used when fetching items for this Menu.
  `Boolean`
  `setItemChecked(int item)`
  Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary.
  `Boolean`
  `setItemChecked(int item, boolean newState)`
  Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary.
  `Boolean`
  `setItemChecked(MenuItem item)`
  Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary.
  `Boolean`
  `setItemChecked(MenuItem item, boolean newState)`
  Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary.
  `Boolean`
  `setItemEnabled(int item)`
  Enables or disables the menu item according to the value of newState, and redraws the menu if necessary.
  `Boolean`
  `setItemEnabled(int item, boolean newState)`
  Enables or disables the menu item according to the value of newState, and redraws the menu if necessary.
  `Boolean`
  `setItemEnabled(MenuItem item)`
  Enables or disables the menu item according to the value of newState, and redraws the menu if necessary.
  `Boolean`
  `setItemEnabled(MenuItem item, boolean newState)`
  Enables or disables the menu item according to the value of newState, and redraws the menu if necessary.
  `boolean`
  `setItemHidden(int item)`
  Hides or shows the menu item according to the value of newState, and redraws the menu if necessary.
  `boolean`
  `setItemHidden(int item, boolean newState)`
  Hides or shows the menu item according to the value of newState, and redraws the menu if necessary.
  `boolean`
  `setItemHidden(MenuItem item)`
  Hides or shows the menu item according to the value of newState, and redraws the menu if necessary.
  `boolean`
  `setItemHidden(MenuItem item, boolean newState)`
  Hides or shows the menu item according to the value of newState, and redraws the menu if necessary.
  `Menu`
  `setItemHiddenProperty(String itemHiddenProperty)`
  Items with this property set to true will be hidden within the menu.
  `Boolean`
  `setItemIcon(int item, String newIcon)`
  Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary.
  `Boolean`
  `setItemIcon(int item, String newIcon, String newDisabledIcon)`
  Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary.
  `Boolean`
  `setItemIcon(MenuItem item, String newIcon)`
  Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary.
  `Boolean`
  `setItemIcon(MenuItem item, String newIcon, String newDisabledIcon)`
  Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary.
  `void`
  `setItemProperties(int item, MenuItem properties)`
  Set arbitrary properties for a particular menu item.
  `Menu`
  `setItems(MenuItem... items)`
  Synonym for `data`
  If this method is called after the component has been drawn/initialized: Synonym for `setData()`.
  `Boolean`
  `setItemTitle(int item, String newTitle)`
  Sets the title of a particular menu item to the string specified by newTitle and redraws the menu if necessary.
  `Boolean`
  `setItemTitle(MenuItem item, String newTitle)`
  Sets the title of a particular menu item to the string specified by newTitle and redraws the menu if necessary.
  `static void`
  `setKeyFieldDefaults(ListGridField keyFieldDefaults)`
  Default properties for the automatically generated key column.
  `Menu`
  `setKeyFieldProperties(ListGridField keyFieldProperties)`
  Custom properties for the automatically generated key column.
  `LogicalStructureObject`
  `setLogicalStructure(MenuLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `Menu`
  `setMenuButtonWidth(Integer menuButtonWidth)`
  For a menu that has a `MenuButton` generated for it automatically (for example when included in a `MenuBar`, the width that the MenuButton should have.
  `Menu`
  `setPlacement(PanelPlacement placement)`
  Where should the menu be placed on the screen?
  `Menu`
  `setShowAnimationEffect(String showAnimationEffect)`
  When this menu is shown how should it animate into view? By default the menu will just show at the specified size/position.
  `Menu`
  `setShowEdges(Boolean showEdges)`
  `showEdges` dynamically defaults to false when the `placement` setting indicates the Menu will be filling a portion of the screen or a panel.
  `Menu`
  `setShowIcons(Boolean showIcons)`
  A boolean, indicating whether the checkmark/custom icon column should be displayed.
  `Menu`
  `setShowKeys(Boolean showKeys)`
  A boolean, indicating whether the shortcut key column should be displayed.
  `Menu`
  `setShowShadow(Boolean showShadow)`
  Whether to show a drop shadow for this Canvas.
  `Menu`
  `setShowSubmenus(Boolean showSubmenus)`
  A boolean, indicating whether the submenu indicator column should be displayed.
  `Menu`
  `setSubmenuConstructor(String submenuConstructor)`
  When using a Tree or hierarchical DataSource as the menu's data, optional subclass of Menu that should be used when generating submenus.
  `Menu`
  `setSubmenuDirection(String submenuDirection)`
  Should submenus show up on our left or right.
  `Menu`
  `setSubmenuDisabledImage(ImgHTMLProperties submenuDisabledImage)`
  Default image to use for the submenu indicator when the item is disabled.
  `Menu`
  `setSubmenuDisabledImage(String submenuDisabledImage)`
  Default image to use for the submenu indicator when the item is disabled.
  `static void`
  `setSubmenuFieldDefaults(ListGridField submenuFieldDefaults)`
  Default properties for the automatically generated submenu column.
  `Menu`
  `setSubmenuFieldProperties(ListGridField submenuFieldProperties)`
  Custom properties for the automatically generated submenu column.
  `Menu`
  `setSubmenuImage(ImgHTMLProperties submenuImage)`
  Default image to use for the submenu indicator.
  `Menu`
  `setSubmenuImage(String submenuImage)`
  Default image to use for the submenu indicator.
  `Menu`
  `setTarget(Canvas target)`
  Optional target canvas for this menu.
  `void`
  `setTitle(String title)`
  When used in a MenuBar, the title of the menu button create will be the title of the Menu.
  `static void`
  `setTitleFieldDefaults(ListGridField titleFieldDefaults)`
  Default properties for the automatically generated title column.
  `Menu`
  `setTitleFieldProperties(ListGridField titleFieldProperties)`
  Custom properties for the automatically generated title column.
  `Menu`
  `setUseKeys(Boolean useKeys)`
  A boolean indicating whether this menu should use shortcut keys.
  `Boolean`
  `showContextMenu()`
  Show this menu as a context menu, that is, immediately adjacent to the current mouse position.

  ### Methods inherited from class com.smartgwt.client.widgets.grid.ListGrid

  `addBodyKeyPressHandler, addCellClickHandler, addCellContextClickHandler, addCellDoubleClickHandler, addCellErrorIconHoverHandler, addCellErrorIconOutHandler, addCellErrorIconOverHandler, addCellHoverHandler, addCellMouseDownHandler, addCellMouseUpHandler, addCellOutHandler, addCellOverHandler, addCellSavedHandler, addCellSelectionChangedHandler, addCellValueHoverHandler, addCriteriaChangedHandler, addData, addData, addData, addDataArrivedHandler, addDataChangedHandler, addDragCompleteHandler, addDrawAreaChangedHandler, addDropCompleteHandler, addEditCompleteHandler, addEditFailedHandler, addEditorEnterHandler, addEditorExitHandler, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addFetchDataHandler, addFieldStateChangedHandler, addFilterEditorSubmitHandler, addFormulaField, addFormulaUpdatedHandler, addGroupByCompleteHandler, addGroupByHandler, addGroupStateChangedHandler, addGroupTreeChangedHandler, addHeaderClickHandler, addHeaderDoubleClickHandler, addHeaderHoverHandler, addHilitesChangedHandler, addRecordClickHandler, addRecordCollapseHandler, addRecordDoubleClickHandler, addRecordDropHandler, addRecordExpandHandler, addRegroupHandler, addRemoveRecordClickHandler, addRowContextClickHandler, addRowEditorEnterHandler, addRowEditorExitHandler, addRowHoverHandler, addRowMouseDownHandler, addRowMouseUpHandler, addRowOutHandler, addRowOverHandler, addSelectionChangedHandler, addSelectionUpdatedHandler, addSetSortHandler, addSort, addSortChangedHandler, addSorterClickHandler, addSorterContextClickHandler, addSummaryField, addViewStateChangedHandler, anySelected, applyCellData, applyRecordData, applySortToData, askForSort, autoFitField, autoFitFields, autoFitFields, cancelEditing, canEditCell, canExpandRecord, canSelectCell, canSelectRecord, cellHasChanges, cellHasErrors, cellHasErrors, cellValueHoverHTML, cellValueIsClipped, chartData, chartData, chartData, chartData, chartData, clearAllCriteria, clearCriteria, clearCriteria, clearCriteria, clearEditValue, clearFieldError, clearFieldError, clearFieldSearchOperator, clearFilterWindowCriteria, clearRowErrors, clearSavedViewState, clearSort, closeGroup, closeRecord, collapseRecord, collapseRecords, configureGrouping, createRecordComponent, dataChangedComplete, dataChangedComplete, deselectAllRecords, deselectRange, deselectRecord, deselectRecord, deselectRecords, deselectRecords, disableHilite, disableHiliting, discardAllEdits, discardAllEdits, discardAllEdits, discardEdits, discardEdits, displayHeaderContextMenu, displaySort, drop, editExistingRecord, editExistingRecord, editFields, editHilites, enableHilite, enableHilite, enableHiliting, enableHiliting, endEditing, expandRecord, expandRecords, exportClientData, exportClientData, exportClientData, exportData, exportData, exportData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRowCount, fetchRowCount, fetchRowCount, fieldIsEditable, fieldIsEditable, fieldIsEditable, fieldIsVisible, filterByEditor, filterData, filterData, filterData, filterData, filterViaAI, filterViaAI, find, findAll, findIndex, findNextEditCell, findNextIndex, findNextIndex, focusInCell, focusInFilterEditor, focusInFilterEditor, focusInRow, freezeField, freezeField, freezeField, freezeField, freezeFields, freezeFields, getAddDropValues, getAddFormulaFieldText, getAddOperation, getAddSummaryFieldText, getAdvancedFieldPickerThreshold, getAdvancedFilteringText, getAiFilterWindow, getAiFilterWindowHint, getAiFilterWindowInstructions, getAiFilterWindowTitle, getAiHiliteWindow, getAiHoverContentsPrefix, getAiHoverRetryDelay, getAiSortFieldMaxRecordsMessage, getAiSortProgressDialog, getAllEditRows, getAllFields, getAllowFilterExpressions, getAllowFilterOperators, getAllowFilterWindow, getAllowRowSpanning, getAlternateBodyStyleName, getAlternateFieldFrequency, getAlternateFieldStyles, getAlternateFieldSuffix, getAlternateRecordFrequency, getAlternateRecordSuffix, getAlwaysShowEditors, getAlwaysShowOperatorIcon, getAnimateFolderEffect, getAnimateFolderMaxRows, getAnimateFolders, getAnimateFolderSpeed, getAnimateFolderTime, getAnimateRemoveRecord, getAnimateRemoveSpeed, getAnimateRemoveTime, getAnimateRollOver, getAnimateRollUnder, getAnimateSelection, getAnimateSelectionUnder, getApplyFormulaAfterSummary, getApplyRowCountToLength, getApplyRowNumberStyle, getApproximateRowCountFormat, getAriaRole, getAriaState, getAriaStateDefaults, getArrowKeyAction, getArrowKeyEditAction, getAsyncErrorCellValue, getAsynchGroupingPrompt, getAsyncMissingCellValue, getAutoComplete, getAutoConfirmSaveEdits, getAutoFetchAsFilter, getAutoFetchData, getAutoFetchDisplayMap, getAutoFetchRowCount, getAutoFetchTextMatchStyle, getAutoFitAllText, getAutoFitClipFields, getAutoFitData, getAutoFitDateFields, getAutoFitExpandField, getAutoFitExpandLengthThreshold, getAutoFitExtraRecords, getAutoFitFieldsFillViewport, getAutoFitFieldText, getAutoFitFieldWidths, getAutoFitHeaderHeights, getAutoFitIconFields, getAutoFitMaxColumns, getAutoFitMaxHeight, getAutoFitMaxRecords, getAutoFitMaxWidth, getAutoFitMaxWidthAsString, getAutoFitTimeFields, getAutoFitWidthApproach, getAutoHideCanvasGrid, getAutoPersistViewState, getAutoSaveEdits, getAutoSizeHeaderSpans, getBackgroundComponent, getBadFormulaResultValue, getBaseStyle, getBlockingRowCountFetch, getBody, getBodyBackgroundColor, getBodyOverflow, getBodyScrollLeft, getBodyScrollTop, getBooleanBaseStyle, getBooleanFalseImage, getBooleanImageHeight, getBooleanImageWidth, getBooleanPartialImage, getBooleanTrueImage, getBriefRowRangeDisplayValue, getCanAcceptDroppedRecords, getCanAddAISortFields, getCanAddAISummaryFields, getCanAddFormulaFields, getCanAddSummaryFields, getCanAutoFitFields, getCancelEditingConfirmationMessage, getCanCollapseGroup, getCanConfigureViaAI, getCanDragRecordsOut, getCanDragSelect, getCanDragSelectText, getCanDropInEmptyArea, getCanEdit, getCanEditHilites, getCanEditTitles, getCanExpandMultipleRecords, getCanExpandRecordProperty, getCanExpandRecords, getCanFocusInEmptyGrid, getCanFreezeFields, getCanGroupBy, getCanHiliteViaAI, getCanHover, getCanMultiGroup, getCanMultiSort, getCanPickFields, getCanPickOmittedFields, getCanRemoveRecords, getCanReorderFields, getCanReorderRecords, getCanRequestRowCount, getCanResizeFields, getCanSelectAll, getCanSelectCells, getCanSelectGroups, getCanSelectSummaryRows, getCanSort, getCanTabToHeader, getCanTabToSorter, getCanvasGridConstructor, getCellAriaState, getCellContextMenu, getCellContextMenuItems, getCellCSSText, getCellElement, getCellErrors, getCellHoverComponent, getCellPadding, getCellPageRect, getCellRole, getCellRowSpan, getCellSelection, getCellStartRow, getCellValue, getCentralStyling, getChartConstructor, getChartType, getCheckboxFieldFalseImage, getCheckboxFieldImageHeight, getCheckboxFieldImageWidth, getCheckboxFieldPartialImage, getCheckboxFieldTrueImage, getChildExpansionMode, getClearAllSortingText, getClearCriteriaOnFilterEditorHide, getClearFilterText, getClearFilterViaAIText, getClearSortFieldText, getClipHeaderTitles, getCollapseGroupOnRowClick, getColumnLeft, getColumnPageLeft, getColumnWidth, getConfigureGroupingText, getConfigureSortText, getConfigureViaAIText, getConfirmCancelEditing, getConfirmDiscardEdits, getConfirmDiscardEditsMessage, getCriteria, getCriteriaIndicatorColor, getCriteriaIndicatorHeaderColor, getCurrentExpansionComponent, getCurrentExpansionComponent, getCurrentFieldWidths, getDataArity, getDataAsJSList, getDataAsRecordList, getDataFetchDelay, getDataFetchMode, getDataPageSize, getDateFormatter, getDatetimeFormatter, getDeepCloneOnEdit, getDefaultDateFieldWidth, getDefaultDateTimeFieldWidth, getDefaultEditableDateFieldWidth, getDefaultEditableDateTimeFieldWidth, getDefaultFields, getDefaultFilterOperator, getDefaultFilterOperatorSuffix, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedValue, getDefaultTimeFieldWidth, getDeferRemoval, getDeselectOnPartialCheckboxClick, getDetailDS, getDetailField, getDisabledGroupByPrompt, getDiscardDataOnSetFetchOperation, getDiscardEditsOnHideField, getDiscardEditsSaveButtonTitle, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDivGrid, getDragData, getDragDataAction, getDragHandleField, getDragHandleFieldTitle, getDragHandleIcon, getDragHandleIconSize, getDragRecategorize, getDragScrollRedrawDelay, getDragTrackerMode, getDragTrackerStyle, getDrawAheadRatio, getDrawAllMaxCells, getDrawArea, getDrawnRowHeight, getDrawnRows, getDropValues, getDuplicateDragMessage, getEditByCell, getEditCol, getEditedCell, getEditedCell, getEditedCell, getEditedCell, getEditedRecord, getEditEvent, getEditFailedBaseStyle, getEditFailedCSSText, getEditFormItem, getEditFormItem, getEditFormulaFieldText, getEditOnF2Keypress, getEditOnFocus, getEditPendingBaseStyle, getEditPendingCSSText, getEditPendingMarkerStyle, getEditRow, getEditSelectionType, getEditSummaryFieldText, getEditValue, getEditValue, getEditValueAsBoolean, getEditValueAsDate, getEditValueAsFloat, getEditValueAsInt, getEditValueAsRecord, getEditValueAsRecordArray, getEditValueAsString, getEditValues, getEditValues, getEmbeddedComponentIndent, getEmbeddedComponentMargin, getEmptyAIHoverContents, getEmptyCellValue, getEmptyMessageStyle, getEmptyRowRangeDisplayValue, getEnforceVClipping, getEnterKeyEditAction, getEnumCriteriaAsInitialValues, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getEscapeKeyEditAction, getEventColumn, getEventColumn, getEventRow, getEventRow, getExactRowCountFormat, getExpandedRecords, getExpansionCanEdit, getExpansionComponent, getExpansionComponentPoolingMode, getExpansionDetailField, getExpansionDetailRelated, getExpansionDetails, getExpansionEditor, getExpansionEditorCollapseOnSave, getExpansionEditorSaveButton, getExpansionEditorSaveButtonTitle, getExpansionEditorSaveDialogPrompt, getExpansionEditorShowSaveDialog, getExpansionField, getExpansionFieldFalseImage, getExpansionFieldImageHeight, getExpansionFieldImageShowRTL, getExpansionFieldImageShowSelected, getExpansionFieldImageStyle, getExpansionFieldImageWidth, getExpansionFieldTrueImage, getExpansionIndent, getExpansionLayout, getExpansionMode, getExpansionRelated, getExpansionScreen, getExplicitFetchDelay, getExportAll, getExportAlternateRowBGColor, getExportBGColor, getExportColumnBGColor, getExportColumnWidthPadding, getExportDefaultBGColor, getExportFieldAlignments, getExportFields, getExportFieldWidths, getExportHeaderHeights, getExportHiddenFieldWidth, getExportIncludeSummaries, getExportRawNumbers, getExportRawValues, getExportRowBGColor, getExportTextColor, getExportWidthScale, getExportWrapCells, getExportWrapHeaderTitles, getFetchDelay, getFetchFields, getFetchFieldsAsString, getFetchOperation, getFetchRequestProperties, getField, getField, getFieldAlignments, getFieldByName, getFieldContentWidth, getFieldCount, getFieldCriteriaText, getFieldName, getFieldNum, getFieldNum, getFieldPickerFieldProperties, getFieldPickerShowSampleValues, getFieldPickerWindow, getFields, getFieldsAsJavaScriptObjects, getFieldSearchOperator, getFieldState, getFieldTitle, getFieldTitle, getFieldVisibilitySubmenuTitle, getFieldWidth, getFieldWidth, getFilterButtonPrompt, getFilterButtonProperties, getFilterByCell, getFilterEditor, getFilterEditorCriteria, getFilterEditorCriteria, getFilterEditorCriteriaAsAdvancedCriteria, getFilterEditorCriterion, getFilterEditorHeight, getFilterEditorProperties, getFilterLocalData, getFilterOnKeypress, getFilterUsingText, getFilterViaAIMode, getFilterViaAIPanelInstructions, getFilterViaAIText, getFilterWindow, getFilterWindowCriteria, getFilterWindowCriteriaIndicator, getFilterWindowFilter, getFilterWindowInstructions, getFilterWindowTitle, getFirstCellStyle, getFixedFieldWidths, getFixedRecordHeights, getFocusRow, getFormattedRowCount, getFormattedRowRange, getFormattedValue, getFormattedValue, getFormulaBuilderSpanTitleSeparator, getFormulaFieldValue, getFreezeFieldText, getFrozenBaseStyle, getFrozenBodyStyleName, getFrozenFieldsMaxWidth, getFrozenFieldsMaxWidthAsInt, getFrozenHeaderBaseStyle, getFrozenHeaderTitleStyle, getFrozenRollOverCanvas, getFrozenRollUnderCanvas, getFullRowRangeDisplayValue, getGenerateClickOnEnter, getGenerateClickOnSpace, getGenerateDoubleClickOnEnter, getGenerateDoubleClickOnSpace, getGridAdditionalCriteriaText, getGridComponents, getGridRenderer, getGridSummary, getGridSummaryData, getGridSummaryRecordProperty, getGroupByAsyncThreshold, getGroupByFields, getGroupByFieldSummaries, getGroupByMaxRecords, getGroupByMaxRecordsExceededMessage, getGroupByText, getGroupedRecordIndex, getGroupIcon, getGroupIconSize, getGroupIconStyle, getGroupIndentSize, getGroupIndexInfo, getGroupLeadingIndent, getGroupMembers, getGroupNodeBaseStyle, getGroupNodeStyle, getGroupSortDirection, getGroupState, getGroupSummaryData, getGroupSummaryData, getGroupSummaryData, getGroupSummaryData, getGroupSummaryRecordProperty, getGroupSummaryStyle, getGroupTitleColumnProperties, getGroupTitleField, getGroupTree, getGroupTreeSelection, getGroupTreeSelection, getGroupTreeSelection, getHeader, getHeaderAriaRole, getHeaderAutoFitEvent, getHeaderBackgroundColor, getHeaderBarStyle, getHeaderBaseStyle, getHeaderButtonAriaRole, getHeaderButtonAriaState, getHeaderButtonProperties, getHeaderContextMenu, getHeaderContextMenuItems, getHeaderHeight, getHeaderHoverAlign, getHeaderHoverHeight, getHeaderHoverOpacity, getHeaderHoverStyle, getHeaderHoverVAlign, getHeaderHoverWidth, getHeaderHoverWrap, getHeaderMenuButton, getHeaderMenuButtonHeight, getHeaderMenuButtonHeightAsString, getHeaderMenuButtonIcon, getHeaderMenuButtonIconHeight, getHeaderMenuButtonIconWidth, getHeaderMenuButtonSnapOffsetLeft, getHeaderMenuButtonWidth, getHeaderRadius, getHeaderShadowColor, getHeaderShadowHOffset, getHeaderShadowSoftness, getHeaderShadowVOffset, getHeaderSpan, getHeaderSpanContextMenuItems, getHeaderSpanHeight, getHeaderTitleStyle, getHeaderTitleVAlign, getHeightForRows, getHeightForRows, getHideEmptySummaryRow, getHideFilterEditorTitle, getHiliteCanReplaceValue, getHiliteEditorSpanTitleSeparator, getHiliteHTMLAfterFormat, getHiliteIconHeight, getHiliteIconLeftPadding, getHiliteIconPosition, getHiliteIconRightPadding, getHiliteIcons, getHiliteIconSize, getHiliteIconWidth, getHiliteProperty, getHiliteReplaceValueFieldTitle, getHiliteRowOnFocus, getHilites, getHiliteState, getHiliteViaAIMode, getHiliteViaAIText, getHoverMode, getHoverScreen, getHoverStyle, getIconCursor, getIconPadding, getImageSize, getImplicitCriteria, getIncludeHilitesInSummaryFields, getIncludeInSummaryProperty, getInitialSort, getInlineEditItemGap, getInstantScrollTrackRedraw, getInvalidSummaryValue, getIsGrouped, getIsSeparatorProperty, getLastCellStyle, getLeaveScrollbarGap, getLinkTextProperty, getLinkTextStyleName, getListEndEditAction, getLoadingDataMessage, getLoadingDataMessageStyle, getLoadingMessage, getLoadingRowCountDisplayIcoHeight, getLoadingRowCountDisplayIcon, getLoadingRowCountDisplayIconWidth, getLocateColumnsBy, getLocateRowsBy, getLongTextEditorThreshold, getLongTextEditorType, getMaxExpandedRecords, getMaxExpandedRecordsPrompt, getMaximumRowCountFormat, getMaxSummaryRowRecords, getMinFieldWidth, getMinHeight, getMinimumCellHeight, getMinimumRowCountFormat, getMissingSummaryFieldValue, getModalEditing, getMultiGroupDialogDefaults, getMultiGroupDialogProperties, getNavigateOnTab, getNeverValidate, getNewRecordRowMessage, getNewSearchText, getNormalBaseStyle, getNormalCellHeight, getNoSavedSearchesText, getNullGroupTitle, getOfflineMessageStyle, getOperatorIcon, getOriginalRecordList, getOriginalResultSet, getOriginBaseStyle, getOverflow, getPendingAsyncCellValue, getPlaceholderAIHoverContents, getPoolComponentsPerColumn, getPreRender, getPreRenderDelay, getPreRenderFormatValues, getPreRenderImageMode, getPreRenderPlaceholderColor, getPreRenderStructureDelay, getPreRenderTransitionDuration, getPreRenderTransitionFrame, getPreRenderTransitionFrameDefaults, getPreserveFocusStylingOnMouseOut, getPreserveWhitespace, getPreventDuplicates, getPrintAutoFit, getPrintBaseStyle, getPrintBooleanBaseStyle, getPrintBooleanFalseImage, getPrintBooleanPartialImage, getPrintBooleanTrueImage, getPrintCheckboxFieldFalseImage, getPrintCheckboxFieldPartialImage, getPrintCheckboxFieldTrueImage, getPrintHeaderStyle, getPrintMaxRows, getPrintWrapCells, getProgressiveLoading, getQuickDrawAheadRatio, getRangeRowCountFormat, getRecord, getRecordBaseStyleProperty, getRecordCanRemoveProperty, getRecordCanSelectProperty, getRecordCellRoleProperty, getRecordComponent, getRecordComponent, getRecordComponentHeight, getRecordComponentPoolingMode, getRecordComponentPosition, getRecordDetailDSProperty, getRecordDropAppearance, getRecordDropPosition, getRecordEditProperty, getRecordEnabledProperty, getRecordIndex, getRecordIndex, getRecordList, getRecordRadius, getRecordRadiusTargets, getRecordRowAriaStateProperty, getRecordRowRoleProperty, getRecords, getRecordScreen, getRecordShowRollOverProperty, getRecordSummaryAttributePrefix, getRecordSummaryBaseStyle, getRelatedDataSource, getRemovedCSSText, getRemoveFieldDefaults, getRemoveFieldProperties, getRemoveFieldTitle, getRemoveIcon, getRemoveIconSize, getRemoveIconStyle, getRemoveOperation, getReselectOnUpdate, getReselectOnUpdateNotifications, getResizeFieldsInRealTime, getResultSet, getReverseRTLAlign, getRollOverCanvas, getRollUnderCanvas, getRotatedHeaderMenuButtonHeight, getRotatedHeaderMenuButtonHeightAsString, getRotatedHeaderMenuButtonWidth, getRotateHeaderTitles, getRowAriaState, getRowCount, getRowCountDisplayPrecision, getRowCountRange, getRowCountStatus, getRowEndEditAction, getRowErrors, getRowHeight, getRowLocatorField, getRowLocatorFieldAsStringArray, getRowNum, getRowNumberField, getRowNumberStart, getRowNumberStyle, getRowPageTop, getRowRangeDisplay, getRowRangeDisplayStyle, getRowRangeDisplayValue, getRowRangeFormat, getRowRole, getRowSpan, getRowSpanEditMode, getRowSpanSelectionMode, getRowTop, getSaveByCell, getSaveCriteriaInViewState, getSaveDefaultSearch, getSavedSearchAdminRole, getSavedSearchAdminSeparator, getSavedSearchDS, getSavedSearchId, getSavedSearchStoredState, getSavedSearchText, getSavedViewState, getSaveLocally, getSaveRequestProperties, getScreenReaderCellSeparator, getScreenReaderIncludeFieldTitles, getScreenReaderNavigateByCell, getScreenReaderRowSeparator, getScreenReaderWriteRowLabelledBy, getScrollRedrawDelay, getScrollToCellXPosition, getScrollToCellYPosition, getScrollWheelRedrawDelay, getSearchForm, getSearchFormAsString, getSearchFormAsValuesManager, getSelectCellTextOnClick, getSelectedCellData, getSelectedRecord, getSelectedRecords, getSelectedRecords, getSelectedState, getSelectHeaderOnSort, getSelection, getSelection, getSelectionAppearance, getSelectionProperty, getSelectionType, getSelectOnEdit, getSelectOnExpandRecord, getSeparatorRowStyle, getShowAllColumns, getShowAllRecords, getShowAsynchGroupingPrompt, getShowBackgroundComponents, getShowCellContextMenus, getShowClippedHeaderTitlesOnHover, getShowClippedValuesOnHover, getShowCollapsedGroupSummary, getShowComplexFields, getShowDetailFields, getShowDropLines, getShowDropOverRollOver, getShowEllipsisWhenClipped, getShowEmptyMessage, getShowErrorIcons, getShowExpansionEditorSaveButton, getShowFilterEditor, getShowFilterEditorHovers, getShowFilterEditorTitle, getShowFilterWindowCriteriaIndicator, getShowGridSummary, getShowGroupSummary, getShowGroupSummaryInHeader, getShowGroupTitleColumn, getShowGroupTitleInFrozenBody, getShowHeader, getShowHeaderContextMenu, getShowHeaderMenuButton, getShowHeaderPartialSelection, getShowHeaderSeparators, getShowHeaderShadow, getShowHeaderSpanContextMenu, getShowHeaderSpanTitlesInFormulaBuilder, getShowHeaderSpanTitlesInHiliteEditor, getShowHeaderSpanTitlesInSortEditor, getShowHiddenFields, getShowHilitesInGroupSummary, getShowHover, getShowHoverComponents, getShowHoverOnDisabledCells, getShowInitialDragHandles, getShowLastHeaderSeparators, getShowNewRecordRow, getShowPartialSelection, getShowPreRenderTransition, getShowRecordComponents, getShowRecordComponentsByCell, getShowRollOver, getShowRollOverCanvas, getShowRollOverInExpansion, getShowRollUnderCanvas, getShowRowNumbers, getShowSavedSearchesByDS, getShowSelectedRollOverCanvas, getShowSelectedRollUnderCanvas, getShowSelectedStyle, getShowSelectionCanvas, getShowSelectionUnderCanvas, getShowSortArrow, getShowSortNumerals, getShowTreeColumnPicker, getShrinkForFreeze, getSingleCellValueProperty, getSkinImgDir, getSkipClipDiv, getSkipLineBreaks, getSort, getSortArrowMenuButtonSpaceOffset, getSortAscendingImage, getSortAscendingImageAsImgHTMLProperties, getSortBinaryByFileName, getSortByGroupFirst, getSortDescendingImage, getSortDescendingImageAsImgHTMLProperties, getSortDirection, getSortEditorSpanTitleSeparator, getSorterButtonTitle, getSortField, getSortFieldAscendingText, getSortFieldCount, getSortFieldDescendingText, getSortNumeralHTML, getSortNumeralMenuButtonSpaceOffset, getSortNumeralStyle, getSortSpecifier, getSortState, getSpanContextMenu, getSpannedHeaderBaseStyle, getSparseFieldState, getStopOnErrors, getStyledRowEnds, getStyleName, getSummaryFieldValue, getSummaryRow, getSummaryRowCriteria, getSummaryRowDataSource, getSummaryRowFetchRequestProperties, getSummaryRowHeight, getSummaryRowStyle, getTableRowStyle, getTallBaseStyle, getTitleField, getTitleFieldValue, getToggleFreezeText, getTotalRows, getTouchScrollRedrawDelay, getTrackerImage, getTrackerImageAsImgHTMLProperties, getUnfreezeFieldText, getUngroupText, getUnknownRowCountDisplayValue, getUnremoveIcon, getUpdateOperation, getUpdateSummariesDuringEditing, getUseAdvancedCriteria, getUseAdvancedFieldPicker, getUseAllDataSourceFields, getUseCellRollOvers, getUseClientFiltering, getUseCopyPasteShortcuts, getUseFlatFields, getUseInlineEditors, getUseInlineFilterEditors, getUseLegacyDefaultFormattedValue, getUseMultiSelectForFilterValueMaps, getUserCriteriaState, getUseRemoteValidators, getUseRowSpanStyling, getValidateByCell, getValidateOnChange, getValueIcon, getValueIconCursor, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getViewState, getVirtualScrolling, getVisibleRows, getWaitForSave, getWarnOnRemoval, getWarnOnRemovalMessage, getWarnOnUnmappedValueFieldChange, getWrapCells, getWrapHeaderSpanTitles, getWrapHeaderTitles, groupBy, groupSortNormalizer, hasChanges, hasChanges, hasErrors, headerHoverHTML, headerTitleClipped, hideDragHandles, hideField, hideField, hideFields, hideFields, hideFields, hideFields, hiliteViaAI, hiliteViaAI, hiliteViaAI, invalidateCache, invalidateRecordComponents, isCheckboxField, isExpanded, isExpansionField, isExportingClientData, isGrouped, isGroupNode, isPartiallySelected, isPreRendering, isRowNumberField, isSelected, isSortField, isSummaryRecord, loadAllRecords, loadAllRecords, loadAllRecords, markForRedraw, markForRedraw, markRecordRemoved, markRecordsRemoved, markRecordsRemoved, markRecordsRemoved, markSelectionRemoved, onInit, openGroup, openRecordDetailGrid, openRecordEditor, preloadImages, preRenderDone, preRenderHTMLReplaced, recalculateGridSummary, recalculateSummaries, recalculateSummaries, recalculateSummaries, recordClick, recordMarkedAsRemoved, redrawHeader, refreshCell, refreshCell, refreshCellStyle, refreshData, refreshData, refreshFields, refreshRecordComponent, refreshRecordComponent, refreshRow, regroup, removeData, removeData, removeData, removeEmbeddedComponent, removeEmbeddedComponent, removeEmbeddedComponent, removeRecordClick, removeSelectedData, removeSelectedData, removeSelectedData, removeSelectedData, reorderField, reorderFields, resizeField, resort, rowClick, rowClick, rowDoubleClick, rowDoubleClick, rowHasChanges, rowHasChanges, rowHasErrors, saveAllEdits, saveAllEdits, saveAllEdits, saveEdits, saveEdits, saveEdits, saveEdits, scrollBodyTo, scrollToCell, scrollToCell, scrollToCell, scrollToColumn, scrollToColumn, scrollToRow, scrollToRow, selectAllRecords, selectRange, selectRange, selectRecord, selectRecord, selectRecord, selectRecord, selectRecords, selectRecords, selectRecords, selectRecords, selectSingleRecord, selectSingleRecord, setAddDropValues, setAddFormulaFieldText, setAddOperation, setAddSummaryFieldText, setAdvancedFieldPickerThreshold, setAdvancedFilteringText, setAiFilterWindowHint, setAiFilterWindowInstructions, setAiFilterWindowTitle, setAiHoverContentsPrefix, setAiHoverRetryDelay, setAiSortFieldMaxRecordsMessage, setAllowFilterExpressions, setAllowFilterOperators, setAllowFilterWindow, setAllowRowSpanning, setAlternateBodyStyleName, setAlternateFieldFrequency, setAlternateFieldStyles, setAlternateFieldSuffix, setAlternateRecordFrequency, setAlternateRecordSuffix, setAlwaysShowEditors, setAlwaysShowOperatorIcon, setAnimateFolderEffect, setAnimateFolderMaxRows, setAnimateFolders, setAnimateFolderSpeed, setAnimateFolderTime, setAnimateRemoveRecord, setAnimateRemoveSpeed, setAnimateRemoveTime, setAnimateRollOver, setAnimateRollUnder, setAnimateSelection, setAnimateSelectionUnder, setApplyFormulaAfterSummary, setApplyRowCountToLength, setApplyRowNumberStyle, setApproximateRowCountFormat, setAriaRole, setArrowKeyAction, setArrowKeyEditAction, setAsyncErrorCellValue, setAsynchGroupingPrompt, setAsyncMissingCellValue, setAutoChildProperties, setAutoComplete, setAutoConfirmSaveEdits, setAutoFetchAsFilter, setAutoFetchData, setAutoFetchDisplayMap, setAutoFetchRowCount, setAutoFetchTextMatchStyle, setAutoFitAllText, setAutoFitClipFields, setAutoFitData, setAutoFitDateFields, setAutoFitExpandField, setAutoFitExpandLengthThreshold, setAutoFitExtraRecords, setAutoFitFieldsFillViewport, setAutoFitFieldText, setAutoFitFieldWidths, setAutoFitHeaderHeights, setAutoFitIconFields, setAutoFitMaxColumns, setAutoFitMaxHeight, setAutoFitMaxRecords, setAutoFitMaxWidth, setAutoFitMaxWidth, setAutoFitTimeFields, setAutoFitWidth, setAutoFitWidthApproach, setAutoHideCanvasGrid, setAutoPersistViewState, setAutoSaveEdits, setAutoSizeHeaderSpans, setBadFormulaResultValue, setBlockingRowCountFetch, setBodyBackgroundColor, setBodyOverflow, setBooleanBaseStyle, setBooleanFalseImage, setBooleanImageHeight, setBooleanImageWidth, setBooleanPartialImage, setBooleanTrueImage, setBriefRowRangeDisplayValue, setCanAcceptDroppedRecords, setCanAddAISortFields, setCanAddAISummaryFields, setCanAddFormulaFields, setCanAddSummaryFields, setCanAutoFitFields, setCancelEditingConfirmationMessage, setCanCollapseGroup, setCanConfigureViaAI, setCanDragRecordsOut, setCanDragSelect, setCanDragSelectText, setCanDropInEmptyArea, setCanEdit, setCanEditHilites, setCanEditTitles, setCanExpandMultipleRecords, setCanExpandRecordProperty, setCanExpandRecords, setCanFocusInEmptyGrid, setCanFreezeFields, setCanGroupBy, setCanHiliteViaAI, setCanHover, setCanMultiGroup, setCanMultiSort, setCanPickFields, setCanPickOmittedFields, setCanRemoveRecords, setCanReorderFields, setCanReorderRecords, setCanRequestRowCount, setCanResizeFields, setCanSelectAll, setCanSelectCells, setCanSelectGroups, setCanSelectRecordCustomizer, setCanSelectSummaryRows, setCanSort, setCanTabToHeader, setCanTabToSorter, setCanvasGridConstructor, setCellContextMenuItemsCustomizer, setCellCSSTextCustomizer, setCellFormatter, setCellPadding, setCellRole, setCellValueHoverFormatter, setCentralStyling, setChartConstructor, setChartType, setCheckboxFieldFalseImage, setCheckboxFieldImageHeight, setCheckboxFieldImageWidth, setCheckboxFieldPartialImage, setCheckboxFieldProperties, setCheckboxFieldTrueImage, setChildExpansionMode, setClearAllSortingText, setClearCriteriaOnFilterEditorHide, setClearFilterText, setClearFilterViaAIText, setClearSortFieldText, setClipHeaderTitles, setCollapseGroupOnRowClick, setConfigureGroupingText, setConfigureSortText, setConfigureViaAIText, setConfirmCancelEditing, setConfirmDiscardEdits, setConfirmDiscardEditsMessage, setCriteriaIndicatorColor, setCriteriaIndicatorHeaderColor, setData, setDataArity, setDataFetchDelay, setDataFetchMode, setDataPageSize, setDataProperties, setDataSource, setDateFormatter, setDateInputFormat, setDatetimeFormatter, setDeepCloneOnEdit, setDefaultDateFieldWidth, setDefaultDateTimeFieldWidth, setDefaultEditableDateFieldWidth, setDefaultEditableDateTimeFieldWidth, setDefaultFields, setDefaultFieldWidthCustomizer, setDefaultFilterOperator, setDefaultFilterOperatorSuffix, setDefaultProperties, setDefaultTimeFieldWidth, setDeferRemoval, setDeselectOnPartialCheckboxClick, setDetailDS, setDetailDS, setDetailField, setDisabledGroupByPrompt, setDiscardDataOnSetFetchOperation, setDiscardEditsOnHideField, setDiscardEditsSaveButtonTitle, setDivGrid, setDontAutoDestroyComponent, setDragDataAction, setDragDataCustomizer, setDragHandleFieldTitle, setDragHandleIcon, setDragHandleIconSize, setDragRecategorize, setDragScrollRedrawDelay, setDragTrackerIconCustomizer, setDragTrackerMode, setDragTrackerStyle, setDragTrackerTitleCustomizer, setDrawAheadRatio, setDrawAllMaxCells, setDropValues, setDuplicateDragMessage, setEditByCell, setEditEvent, setEditFailedBaseStyle, setEditFailedCSSText, setEditFormulaFieldText, setEditOnF2Keypress, setEditOnFocus, setEditorCustomizer, setEditorValueMap, setEditorValueMap, setEditPendingBaseStyle, setEditPendingCSSText, setEditPendingMarkerStyle, setEditSelectionType, setEditSummaryFieldText, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValues, setEmbeddedComponentIndent, setEmbeddedComponentMargin, setEmptyAIHoverContents, setEmptyCellValue, setEmptyMessageStyle, setEmptyRowRangeDisplayValue, setEnforceVClipping, setEnterKeyEditAction, setEnumCriteriaAsInitialValues, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setEscapeKeyEditAction, setExactRowCountFormat, setExpansionCanEdit, setExpansionComponentPoolingMode, setExpansionEditorSaveDialogPrompt, setExpansionEditorShowSaveDialog, setExpansionFieldFalseImage, setExpansionFieldImageHeight, setExpansionFieldImageShowRTL, setExpansionFieldImageShowSelected, setExpansionFieldImageStyle, setExpansionFieldImageWidth, setExpansionFieldTrueImage, setExpansionIndent, setExpansionMode, setExpansionScreen, setExplicitFetchDelay, setExportAll, setExportAlternateRowBGColor, setExportColumnWidthPadding, setExportDefaultBGColor, setExportFieldAlignments, setExportFields, setExportFieldWidths, setExportHeaderHeights, setExportHiddenFieldWidth, setExportIncludeSummaries, setExportRawNumbers, setExportRawValues, setExportWidthScale, setExportWrapCells, setExportWrapHeaderTitles, setFastCellUpdates, setFetchDelay, setFetchFields, setFetchFields, setFetchOperation, setFetchRequestProperties, setFieldAlign, setFieldButtonProperties, setFieldCellAlign, setFieldCellIcon, setFieldCriteriaText, setFieldError, setFieldError, setFieldHeaderBaseStyle, setFieldHeaderTitleStyle, setFieldIcon, setFieldMaxWidth, setFieldMinWidth, setFieldPickerFieldProperties, setFieldPickerShowSampleValues, setFieldProperties, setFieldProperties, setFields, setFields, setFieldSearchOperator, setFieldState, setFieldTitle, setFieldTitle, setFieldVisibilitySubmenuTitle, setFilterButtonPrompt, setFilterButtonProperties, setFilterByCell, setFilterEditorCriteria, setFilterEditorHeight, setFilterEditorProperties, setFilterEditorProperties, setFilterLocalData, setFilterOnKeypress, setFilterUsingText, setFilterViaAIMode, setFilterViaAIPanelInstructions, setFilterViaAIText, setFilterWindowCriteria, setFilterWindowInstructions, setFilterWindowTitle, setFirstCellStyle, setFixedFieldWidths, setFixedRecordHeights, setFormulaBuilderSpanTitleSeparator, setFreezeFieldText, setFrozenBaseStyle, setFrozenBodyStyleName, setFrozenFieldsMaxWidth, setFrozenFieldsMaxWidth, setFrozenHeaderBaseStyle, setFrozenHeaderTitleStyle, setFullRowRangeDisplayValue, setGenerateClickOnEnter, setGenerateClickOnSpace, setGenerateDoubleClickOnEnter, setGenerateDoubleClickOnSpace, setGridAdditionalCriteriaText, setGridComponents, setGridComponents, setGridComponents, setGridSummaryRecordProperty, setGroupByAsyncThreshold, setGroupByField, setGroupByField, setGroupByFieldSummaries, setGroupByMaxRecords, setGroupByMaxRecordsExceededMessage, setGroupByText, setGroupIcon, setGroupIconSize, setGroupIconStyle, setGroupIndentSize, setGroupLeadingIndent, setGroupNodeBaseStyle, setGroupNodeStyle, setGroupSortDirection, setGroupSortNormalizer, setGroupStartOpen, setGroupStartOpen, setGroupState, setGroupSummaryRecordProperty, setGroupSummaryStyle, setGroupTitleColumnProperties, setGroupTitleField, setHeaderAriaRole, setHeaderAutoFitEvent, setHeaderBackgroundColor, setHeaderBarStyle, setHeaderBaseStyle, setHeaderButtonAriaRole, setHeaderButtonAriaState, setHeaderButtonProperties, setHeaderHeight, setHeaderHoverAlign, setHeaderHoverFormatter, setHeaderHoverHeight, setHeaderHoverOpacity, setHeaderHoverStyle, setHeaderHoverVAlign, setHeaderHoverWidth, setHeaderHoverWrap, setHeaderMenuButtonHeight, setHeaderMenuButtonHeight, setHeaderMenuButtonIcon, setHeaderMenuButtonIconHeight, setHeaderMenuButtonIconWidth, setHeaderMenuButtonSnapOffsetLeft, setHeaderMenuButtonWidth, setHeaderRadius, setHeaderShadowColor, setHeaderShadowHOffset, setHeaderShadowSoftness, setHeaderShadowVOffset, setHeaderSpanBaseStyle, setHeaderSpanButtonProperties, setHeaderSpanHeaderTitle, setHeaderSpanHeight, setHeaderSpans, setHeaderSpanTitle, setHeaderSpanTitleStyle, setHeaderTitleStyle, setHeaderTitleVAlign, setHideEmptySummaryRow, setHideFilterEditorTitle, setHideOnPhone, setHideOnTablet, setHiliteCanReplaceValue, setHiliteEditorSpanTitleSeparator, setHiliteHTMLAfterFormat, setHiliteIconHeight, setHiliteIconLeftPadding, setHiliteIconPosition, setHiliteIconRightPadding, setHiliteIcons, setHiliteIconSize, setHiliteIconWidth, setHiliteProperty, setHiliteReplaceValueFieldTitle, setHiliteRowOnFocus, setHilites, setHiliteState, setHiliteViaAIMode, setHiliteViaAIText, setHoverCustomizer, setHoverMode, setHoverScreen, setHoverStyle, setIconCursor, setIconPadding, setImageSize, setImplicitCriteria, setImplicitCriteria, setImplicitCriteria, setInactiveCellFormatter, setIncludeHilitesInSummaryFields, setIncludeInSummaryProperty, setInitialSort, setInlineEditItemGap, setInstantScrollTrackRedraw, setInvalidSummaryValue, setIsSeparatorProperty, setLastCellStyle, setLeaveHeaderMenuButtonSpace, setLeaveScrollbarGap, setLinkTextProperty, setLinkTextStyleName, setListEndEditAction, setLoadingDataMessage, setLoadingDataMessageStyle, setLoadingMessage, setLoadingRowCountDisplayIcoHeight, setLoadingRowCountDisplayIcon, setLoadingRowCountDisplayIconWidth, setLocateColumnsBy, setLocateRowsBy, setLogicalStructure, setLongTextEditorThreshold, setLongTextEditorType, setMaxExpandedRecords, setMaxExpandedRecordsPrompt, setMaximumRowCountFormat, setMaxSummaryRowRecords, setMinFieldWidth, setMinHeight, setMinimumCellHeight, setMinimumRowCountFormat, setMissingSummaryFieldValue, setModalEditing, setMultiGroupDialogDefaults, setMultiGroupDialogProperties, setMultiSortDialogDefaults, setMultiSortDialogProperties, setNavigateOnTab, setNeverValidate, setNewRecordRowMessage, setNewSearchText, setNormalBaseStyle, setNormalCellHeight, setNoSavedSearchesText, setNullGroupTitle, setOfflineMessageStyle, setOriginBaseStyle, setOverflow, setPendingAsyncCellValue, setPlaceholderAIHoverContents, setPoolComponentsPerColumn, setPreRender, setPreRenderDelay, setPreRenderFormatValues, setPreRenderImageMode, setPreRenderPlaceholderColor, setPreRenderStructureDelay, setPreRenderTransitionDuration, setPreRenderTransitionFrameDefaults, setPreserveFocusStylingOnMouseOut, setPreserveWhitespace, setPreventDuplicates, setPrintAutoFit, setPrintBaseStyle, setPrintBooleanBaseStyle, setPrintBooleanFalseImage, setPrintBooleanPartialImage, setPrintBooleanTrueImage, setPrintCheckboxFieldFalseImage, setPrintCheckboxFieldPartialImage, setPrintCheckboxFieldTrueImage, setPrintHeaderStyle, setPrintMaxRows, setPrintWrapCells, setProgressiveLoading, setQuickDrawAheadRatio, setRangeRowCountFormat, setRecordBaseStyleProperty, setRecordCanRemoveProperty, setRecordCanSelectProperty, setRecordCellRoleProperty, setRecordComponentHeight, setRecordComponentPoolingMode, setRecordComponentPosition, setRecordDetailDSProperty, setRecordDropAppearance, setRecordEditProperty, setRecordEnabledProperty, setRecordRadius, setRecordRadiusTargets, setRecordRowAriaStateProperty, setRecordRowRoleProperty, setRecords, setRecordScreen, setRecordShowRollOverProperty, setRecordSummaryAttributePrefix, setRecordSummaryBaseStyle, setRemovedCSSText, setRemoveFieldProperties, setRemoveFieldTitle, setRemoveIcon, setRemoveIconSize, setRemoveIconStyle, setRemoveOperation, setReselectOnUpdate, setReselectOnUpdateNotifications, setResizeFieldsInRealTime, setReverseRTLAlign, setRollOverCanvasProperties, setRollUnderCanvasProperties, setRotatedHeaderMenuButtonHeight, setRotatedHeaderMenuButtonHeight, setRotatedHeaderMenuButtonWidth, setRotateHeaderTitles, setRowAriaState, setRowCountDisplayPrecision, setRowEndEditAction, setRowErrors, setRowErrors, setRowLocatorField, setRowLocatorField, setRowNumberFieldProperties, setRowNumberStart, setRowNumberStyle, setRowRangeDisplayStyle, setRowRangeFormat, setRowRole, setRowSpanEditMode, setRowSpanSelectionMode, setSaveByCell, setSaveCriteriaInViewState, setSaveDefaultSearch, setSavedSearchAdminRole, setSavedSearchDS, setSavedSearchId, setSavedSearchStoredState, setSavedSearchText, setSaveLocally, setSaveRequestProperties, setScreenReaderCellSeparator, setScreenReaderIncludeFieldTitles, setScreenReaderNavigateByCell, setScreenReaderRowSeparator, setScreenReaderWriteRowLabelledBy, setScrollRedrawDelay, setScrollToCellXPosition, setScrollToCellYPosition, setScrollWheelRedrawDelay, setSearchForm, setSearchForm, setSearchForm, setSelectCellTextOnClick, setSelectedState, setSelectHeaderOnSort, setSelectionAppearance, setSelectionCanvasProperties, setSelectionProperty, setSelectionType, setSelectionUnderCanvasProperties, setSelectOnEdit, setSelectOnExpandRecord, setSeparatorRowStyle, setShowAllColumns, setShowAllRecords, setShowAsynchGroupingPrompt, setShowBackgroundComponents, setShowCellContextMenus, setShowClippedHeaderTitlesOnHover, setShowClippedValuesOnHover, setShowCollapsedGroupSummary, setShowComplexFields, setShowDetailFields, setShowDropLines, setShowDropOverRollOver, setShowEllipsisWhenClipped, setShowEmptyMessage, setShowErrorIcons, setShowFilterEditor, setShowFilterEditorHovers, setShowFilterEditorTitle, setShowFilterWindowCriteriaIndicator, setShowGridSummary, setShowGroupSummary, setShowGroupSummaryInHeader, setShowGroupTitleColumn, setShowGroupTitleInFrozenBody, setShowHeader, setShowHeaderContextMenu, setShowHeaderMenuButton, setShowHeaderPartialSelection, setShowHeaderSeparators, setShowHeaderShadow, setShowHeaderSpanContextMenu, setShowHeaderSpanTitlesInFormulaBuilder, setShowHeaderSpanTitlesInHiliteEditor, setShowHeaderSpanTitlesInSortEditor, setShowHiddenFields, setShowHilitesInGroupSummary, setShowHover, setShowHoverComponents, setShowHoverOnDisabledCells, setShowInitialDragHandles, setShowLastHeaderSeparators, setShowNewRecordRow, setShowPartialSelection, setShowPreRenderTransition, setShowRecordComponents, setShowRecordComponentsByCell, setShowRollOver, setShowRollOverCanvas, setShowRollOverInExpansion, setShowRollUnderCanvas, setShowRowNumbers, setShowSavedSearchesByDS, setShowSelectedRollOverCanvas, setShowSelectedRollUnderCanvas, setShowSelectedStyle, setShowSelectionCanvas, setShowSelectionUnderCanvas, setShowSortArrow, setShowSortNumerals, setShowTreeColumnPicker, setShrinkForFreeze, setSingleCellValueProperty, setSkinImgDir, setSkipClipDiv, setSkipLineBreaks, setSort, setSortArrowMenuButtonSpaceOffset, setSortAscendingImage, setSortAscendingImage, setSortBinaryByFileName, setSortByGroupFirst, setSortDescendingImage, setSortDescendingImage, setSortDirection, setSortEditorSpanTitleSeparator, setSorterButtonTitle, setSortField, setSortField, setSortField, setSortFieldAscendingText, setSortFieldDescendingText, setSortNumeralHTMLCustomizer, setSortNumeralMenuButtonSpaceOffset, setSortNumeralStyle, setSortState, setSpannedHeaderBaseStyle, setSparseFieldState, setStopOnErrors, setStyledRowEnds, setStyleName, setSummaryRowCriteria, setSummaryRowDataSource, setSummaryRowFetchRequestProperties, setSummaryRowHeight, setSummaryRowStyle, setTableRowStyle, setTallBaseStyle, setTitleField, setTouchScrollRedrawDelay, setTrackerImage, setTrackerImage, setUnfreezeFieldText, setUngroupText, setUnknownRowCountDisplayValue, setUnremoveIcon, setUpdateOperation, setUpdateSummariesDuringEditing, setUseAdvancedCriteria, setUseAdvancedFieldPicker, setUseAllDataSourceFields, setUseCellRollOvers, setUseClientFiltering, setUseCopyPasteShortcuts, setUseFlatFields, setUseInlineEditors, setUseInlineFilterEditors, setUseLegacyDefaultFormattedValue, setUseMultiSelectForFilterValueMaps, setUserCriteriaState, setUseRemoteValidators, setUserFormula, setUserFormula, setUserFormula, setUserFormula, setUserFormulaText, setUserFormulaText, setUserFormulaText, setUserFormulaText, setUseRowSpanStyling, setUserSummary, setUserSummary, setUserSummary, setUserSummary, setUserSummaryText, setUserSummaryText, setUserSummaryText, setUserSummaryText, setValidateByCell, setValidateOnChange, setValueIconHeight, setValueIconLeftPadding, setValueIconRightPadding, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setViewState, setVirtualScrolling, setWaitForSave, setWarnOnRemoval, setWarnOnRemovalMessage, setWarnOnUnmappedValueFieldChange, setWrapCells, setWrapHeaderSpanTitles, setWrapHeaderTitles, shouldIncludeHiliteInSummaryField, showAIFilterWindow, showAIHiliteWindow, showDragHandles, showField, showField, showFields, showFields, showFields, showFields, showFilterWindow, showRecordComponent, sort, sort, sort, sort, startEditing, startEditing, startEditing, startEditing, startEditingNew, startEditingNew, startEditingNew, startEditingNew, stopHover, summaryUpdated, toggleSort, transferRecords, transferSelectedData, transferSelectedData, unfreezeField, unfreezeField, unfreezeField, unfreezeField, unfreezeFields, unfreezeFields, ungroup, unmarkRecordRemoved, unsort, updateData, updateData, updateData, updateRecordComponent, userSelectAllRecords, validateCell, validateCell, validateRow, willAcceptDrop, willFetchData, willFetchData`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

  `setDefaultProperties, setLogicalStructure`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

  `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersAsStringArray, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDefaultHeight, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowFocusOutline, getShowPointer, getShowResizeBar, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getSuppressRedraw, getTabIndex, getTestDataContext, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowFocusOutline, setShowPointer, setShowResizeBar, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setSuppressRedraw, setTabIndex, setTestDataContext, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Field Details

  - ### ICON_FIELD

    public static final ListGridField ICON_FIELD

  - ### TITLE_FIELD

    public static final ListGridField TITLE_FIELD

  - ### KEY_FIELD

    public static final ListGridField KEY_FIELD

  - ### SUBMENU_FIELD

    public static final ListGridField SUBMENU_FIELD

- ## Constructor Details

  - ### Menu

    public Menu()

  - ### Menu

    public Menu(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static Menu getOrCreateRef(JavaScriptObject jsObj)

  - ### getTestInstance

    protected Menu getTestInstance()
    Overrides:
      `getTestInstance` in class `ListGrid`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `ListGrid`

  - ### setAlternateRecordStyles

    public Menu setAlternateRecordStyles(Boolean alternateRecordStyles)
    Explicitly disable alternateRecordStyles at the menu level by default so setting to true for all ListGrids will not impact menus' appearance.
    Overrides:
      `setAlternateRecordStyles` in class `ListGrid`
    Parameters:
      `alternateRecordStyles` - New alternateRecordStyles value. Default value is false
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - Grid cells Example

  - ### getAlternateRecordStyles

    public Boolean getAlternateRecordStyles()
    Explicitly disable alternateRecordStyles at the menu level by default so setting to true for all ListGrids will not impact menus' appearance.
    Overrides:
      `getAlternateRecordStyles` in class `ListGrid`
    Returns:
      Current alternateRecordStyles value. Default value is false
    See Also:
      - Grid cells Example

  - ### setAutoDismiss

    public Menu setAutoDismiss(Boolean autoDismiss)
    When false, when a menu item is chosen (via mouse click or keyboard), the menu is not automatically hidden, staying in place for further interactivity
    Parameters:
      `autoDismiss` - New autoDismiss value. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `setCascadeAutoDismiss(java.lang.Boolean)`

  - ### getAutoDismiss

    public Boolean getAutoDismiss()
    When false, when a menu item is chosen (via mouse click or keyboard), the menu is not automatically hidden, staying in place for further interactivity
    Returns:
      Current autoDismiss value. Default value is true
    See Also:
      - `getCascadeAutoDismiss()`

  - ### setAutoDismissOnBlur

    public Menu setAutoDismissOnBlur(Boolean autoDismissOnBlur)
    When false, when a user clicks outside the menu, or hits the Escape key, this menu will not be automatically hidden, staying in place for further interactivity.
    Parameters:
      `autoDismissOnBlur` - New autoDismissOnBlur value. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getAutoDismissOnBlur

    public Boolean getAutoDismissOnBlur()
    When false, when a user clicks outside the menu, or hits the Escape key, this menu will not be automatically hidden, staying in place for further interactivity.
    Returns:
      Current autoDismissOnBlur value. Default value is true

  - ### setAutoDraw

    public Menu setAutoDraw(Boolean autoDraw)
    Menus will not draw on initialization, until they're explicitly show()n

    Note : This is an advanced setting

    Overrides:
      `setAutoDraw` in class `BaseWidget`
    Parameters:
      `autoDraw` - New autoDraw value. Default value is false
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `Drawing overview and related methods`

  - ### getAutoDraw

    public Boolean getAutoDraw()
    Menus will not draw on initialization, until they're explicitly show()n
    Overrides:
      `getAutoDraw` in class `BaseWidget`
    Returns:
      Current autoDraw value. Default value is false
    See Also:
      - `Drawing overview and related methods`

  - ### setBaseStyle

    public Menu setBaseStyle(String baseStyle)
    CSS style for a normal cell
    Overrides:
      `setBaseStyle` in class `ListGrid`
    Parameters:
      `baseStyle` - New baseStyle value. Default value is "menu"
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `CSSStyleName`

  - ### getBaseStyle

    public String getBaseStyle()
    CSS style for a normal cell
    Overrides:
      `getBaseStyle` in class `ListGrid`
    Returns:
      Current baseStyle value. Default value is "menu"
    See Also:
      - `CSSStyleName`

  - ### setBodyStyleName

    public Menu setBodyStyleName(String bodyStyleName)
    CSS style used for the body of this menu when there is no icon field. When there is an icon field, then `iconBodyStyleName`, if set, will override this setting.

    If applying a background-color to the body via a CSS style applied using this property, be sure to set `bodyBackgroundColor` to `null`.

    Overrides:
      `setBodyStyleName` in class `ListGrid`
    Parameters:
      `bodyStyleName` - New bodyStyleName value. Default value is "normal"
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `setFillSpaceStyleName(java.lang.String)`
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### getBodyStyleName

    public String getBodyStyleName()
    CSS style used for the body of this menu when there is no icon field. When there is an icon field, then `iconBodyStyleName`, if set, will override this setting.

    If applying a background-color to the body via a CSS style applied using this property, be sure to set `bodyBackgroundColor` to `null`.

    Overrides:
      `getBodyStyleName` in class `ListGrid`
    Returns:
      Current bodyStyleName value. Default value is "normal"
    See Also:
      - `getFillSpaceStyleName()`
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### setCancelButtonTitle

    public Menu setCancelButtonTitle(String cancelButtonTitle) throws IllegalStateException
    Title for the "Done" button shown when the `NavigationBar` is present.
    Parameters:
      `cancelButtonTitle` - New cancelButtonTitle value. Default value is "Done"
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `HTMLString`

  - ### getCancelButtonTitle

    public String getCancelButtonTitle()
    Title for the "Done" button shown when the `NavigationBar` is present.
    Returns:
      Current cancelButtonTitle value. Default value is "Done"
    See Also:
      - `HTMLString`

  - ### setCanSaveSearches

    public Menu setCanSaveSearches(boolean canSaveSearches) throws IllegalStateException
    Option to save searches is disabled for menus

    Note : This is an advanced setting

    Overrides:
      `setCanSaveSearches` in class `ListGrid`
    Parameters:
      `canSaveSearches` - New canSaveSearches value. Default value is false
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCanSaveSearches

    public boolean getCanSaveSearches()
    Option to save searches is disabled for menus
    Overrides:
      `getCanSaveSearches` in class `ListGrid`
    Returns:
      Current canSaveSearches value. Default value is false

  - ### setCanSelectParentItems

    public Menu setCanSelectParentItems(Boolean canSelectParentItems)
    If true, clicking or pressing Enter on a menu item that has a submenu will select that item (with standard behavior of hiding the menus, calling click handlers, etc) instead of showing the submenu.
    Parameters:
      `canSelectParentItems` - New canSelectParentItems value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `Selection`
      - Tree Binding Example

  - ### getCanSelectParentItems

    public Boolean getCanSelectParentItems()
    If true, clicking or pressing Enter on a menu item that has a submenu will select that item (with standard behavior of hiding the menus, calling click handlers, etc) instead of showing the submenu.
    Returns:
      Current canSelectParentItems value. Default value is null
    See Also:
      - `Selection`
      - Tree Binding Example

  - ### setCanShowFilterEditor

    public Menu setCanShowFilterEditor(boolean canShowFilterEditor) throws IllegalStateException
    Option to show filter editor is disabled for menus

    Note : This is an advanced setting

    Overrides:
      `setCanShowFilterEditor` in class `ListGrid`
    Parameters:
      `canShowFilterEditor` - New canShowFilterEditor value. Default value is false
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `ListGrid.setShowFilterEditorTitle(java.lang.String)`
      - `ListGrid.setHideFilterEditorTitle(java.lang.String)`
      - Filter Example

  - ### getCanShowFilterEditor

    public boolean getCanShowFilterEditor()
    Option to show filter editor is disabled for menus
    Overrides:
      `getCanShowFilterEditor` in class `ListGrid`
    Returns:
      Current canShowFilterEditor value. Default value is false
    See Also:
      - `ListGrid.getShowFilterEditorTitle()`
      - `ListGrid.getHideFilterEditorTitle()`
      - Filter Example

  - ### setCascadeAutoDismiss

    public Menu setCascadeAutoDismiss(Boolean cascadeAutoDismiss)
    When true any generated submenus will inherit `autoDismiss` from this menu.
    Parameters:
      `cascadeAutoDismiss` - New cascadeAutoDismiss value. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getCascadeAutoDismiss

    public Boolean getCascadeAutoDismiss()
    When true any generated submenus will inherit `autoDismiss` from this menu.
    Returns:
      Current cascadeAutoDismiss value. Default value is true

  - ### setCellHeight

    public Menu setCellHeight(int cellHeight)
    The height of each item in the menu, in pixels.
    Overrides:
      `setCellHeight` in class `ListGrid`
    Parameters:
      `cellHeight` - New cellHeight value. Default value is 20
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `Sizing overview and related methods`

  - ### getCellHeight

    public int getCellHeight()
    The height of each item in the menu, in pixels.
    Overrides:
      `getCellHeight` in class `ListGrid`
    Returns:
      Current cellHeight value. Default value is 20
    See Also:
      - `Sizing overview and related methods`

  - ### setCheckmarkDisabledImage

    public Menu setCheckmarkDisabledImage(String checkmarkDisabledImage) throws IllegalStateException
    Default image to display for `check-marked items` when the item is disabled. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.
    Parameters:
      `checkmarkDisabledImage` - New checkmarkDisabledImage value. Default value is {...}
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getCheckmarkDisabledImage

    public String getCheckmarkDisabledImage()
    Default image to display for `check-marked items` when the item is disabled. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.
    Returns:
      Current checkmarkDisabledImage value. Default value is {...}
    See Also:
      - `SCImgURL`

  - ### setCheckmarkDisabledImage

    public Menu setCheckmarkDisabledImage(ImgHTMLProperties checkmarkDisabledImage) throws IllegalStateException
    Default image to display for `check-marked items` when the item is disabled. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.
    Parameters:
      `checkmarkDisabledImage` - New checkmarkDisabledImage value. Default value is {...}
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getCheckmarkDisabledImageAsImgHTMLProperties

    public ImgHTMLProperties getCheckmarkDisabledImageAsImgHTMLProperties()
    Default image to display for `check-marked items` when the item is disabled. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.
    Returns:
      Current checkmarkDisabledImage value. Default value is {...}
    See Also:
      - `SCImgURL`

  - ### setCheckmarkImage

    public Menu setCheckmarkImage(String checkmarkImage) throws IllegalStateException
    Default image to display for `check-marked items`. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.
    Parameters:
      `checkmarkImage` - New checkmarkImage value. Default value is {...}
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getCheckmarkImage

    public String getCheckmarkImage()
    Default image to display for `check-marked items`. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.
    Returns:
      Current checkmarkImage value. Default value is {...}
    See Also:
      - `SCImgURL`

  - ### setCheckmarkImage

    public Menu setCheckmarkImage(ImgHTMLProperties checkmarkImage) throws IllegalStateException
    Default image to display for `check-marked items`. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.
    Parameters:
      `checkmarkImage` - New checkmarkImage value. Default value is {...}
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getCheckmarkImageAsImgHTMLProperties

    public ImgHTMLProperties getCheckmarkImageAsImgHTMLProperties()
    Default image to display for `check-marked items`. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.
    Returns:
      Current checkmarkImage value. Default value is {...}
    See Also:
      - `SCImgURL`

  - ### setData

    public Menu setData(MenuItem... data)
    An array of menuItem objects, specifying the menu items this menu should show.

    Data may also be set to a `Tree` in which case a hierarchy of menus and submenus will automatically be generated to match the tree structure. See also `dataSource` for dynamically fetching menuItems and submenus from a hierarchical DataSource.

    Note that items that are marked as `hidden` will be automatically filtered out of the data dispayed to the user. To retrieve the full set of items at runtime, including hidden items, use `getAllItems()`.
    If this method is called after the component has been drawn/initialized: Change the set of items to display in this menu. Note that if `filterHiddenItems` is true and any items are `hidden`, data supplied as an Array will be converted to a `FilteredList` in order to filter out hidden items. To get the full specified data set as an array, including hidden items, use `getAllItems()`.

    Parameters:
      `data` - new items for this menu. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - Appearance Example

  - ### setData

    public Menu setData(Record... data)
    An array of menuItem objects, specifying the menu items this menu should show.

    Data may also be set to a `Tree` in which case a hierarchy of menus and submenus will automatically be generated to match the tree structure. See also `dataSource` for dynamically fetching menuItems and submenus from a hierarchical DataSource.

    Note that items that are marked as `hidden` will be automatically filtered out of the data dispayed to the user. To retrieve the full set of items at runtime, including hidden items, use `getAllItems()`.
    If this method is called after the component has been drawn/initialized: Change the set of items to display in this menu. Note that if `filterHiddenItems` is true and any items are `hidden`, data supplied as an Array will be converted to a `FilteredList` in order to filter out hidden items. To get the full specified data set as an array, including hidden items, use `getAllItems()`.

    Overrides:
      `setData` in class `ListGrid`
    Parameters:
      `data` - new items for this menu. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - Appearance Example

  - ### setData

    public Menu setData(Tree data)
    An array of menuItem objects, specifying the menu items this menu should show.

    Data may also be set to a `Tree` in which case a hierarchy of menus and submenus will automatically be generated to match the tree structure. See also `dataSource` for dynamically fetching menuItems and submenus from a hierarchical DataSource.

    Note that items that are marked as `hidden` will be automatically filtered out of the data dispayed to the user. To retrieve the full set of items at runtime, including hidden items, use `getAllItems()`.
    If this method is called after the component has been drawn/initialized: Change the set of items to display in this menu. Note that if `filterHiddenItems` is true and any items are `hidden`, data supplied as an Array will be converted to a `FilteredList` in order to filter out hidden items. To get the full specified data set as an array, including hidden items, use `getAllItems()`.

    Parameters:
      `data` - new items for this menu. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - Appearance Example

  - ### setData

    public Menu setData(RecordList data)
    An array of menuItem objects, specifying the menu items this menu should show.

    Data may also be set to a `Tree` in which case a hierarchy of menus and submenus will automatically be generated to match the tree structure. See also `dataSource` for dynamically fetching menuItems and submenus from a hierarchical DataSource.

    Note that items that are marked as `hidden` will be automatically filtered out of the data dispayed to the user. To retrieve the full set of items at runtime, including hidden items, use `getAllItems()`.
    If this method is called after the component has been drawn/initialized: Change the set of items to display in this menu. Note that if `filterHiddenItems` is true and any items are `hidden`, data supplied as an Array will be converted to a `FilteredList` in order to filter out hidden items. To get the full specified data set as an array, including hidden items, use `getAllItems()`.

    Overrides:
      `setData` in class `ListGrid`
    Parameters:
      `data` - new items for this menu. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - Appearance Example

  - ### setDataSource

    public Menu setDataSource(DataSource dataSource) throws IllegalStateException
    Optional DataSource to fetch menuItems and submenus from, instead of using `items`. May be specified as a DataSource instance or the String ID of a DataSource.

    Data is tree-based in menus, so the provided DataSource should be set up for hierarchical fetching - see the `Tree Data Binding overview`.

    Note that, although Menu is a subclass of `ListGrid`, some APIs, like `setCriteria` and `autoFetchData` are not supported in menus. If a dataSource is supplied, it is automatically fetched against as required, without the need for autoFetchData. To apply criteria to the fetches made in this way, see `initialCriteria`.
    Moreover, fetchData() is also an example of a ListGrid API that doesn't apply to menu, and, as was done for setCriteria() and other APIs like setCriteria().

    Specified by:
      `setDataSource` in interface `DataBoundComponent`
    Overrides:
      `setDataSource` in class `ListGrid`
    Parameters:
      `dataSource` - New dataSource value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `DataBinding`
      - DataSource fields Example

  - ### getDataSource

    public DataSource getDataSource()
    Optional DataSource to fetch menuItems and submenus from, instead of using `items`. May be specified as a DataSource instance or the String ID of a DataSource.

    Data is tree-based in menus, so the provided DataSource should be set up for hierarchical fetching - see the `Tree Data Binding overview`.

    Note that, although Menu is a subclass of `ListGrid`, some APIs, like `setCriteria` and `autoFetchData` are not supported in menus. If a dataSource is supplied, it is automatically fetched against as required, without the need for autoFetchData. To apply criteria to the fetches made in this way, see `initialCriteria`.
    Moreover, fetchData() is also an example of a ListGrid API that doesn't apply to menu, and, as was done for setCriteria() and other APIs like setCriteria().

    Specified by:
      `getDataSource` in interface `DataBoundComponent`
    Overrides:
      `getDataSource` in class `ListGrid`
    Returns:
      Current dataSource value. Default value is null

  - ### setDataSource

    public Menu setDataSource(String dataSource) throws IllegalStateException
    Optional DataSource to fetch menuItems and submenus from, instead of using `items`. May be specified as a DataSource instance or the String ID of a DataSource.

    Data is tree-based in menus, so the provided DataSource should be set up for hierarchical fetching - see the `Tree Data Binding overview`.

    Note that, although Menu is a subclass of `ListGrid`, some APIs, like `setCriteria` and `autoFetchData` are not supported in menus. If a dataSource is supplied, it is automatically fetched against as required, without the need for autoFetchData. To apply criteria to the fetches made in this way, see `initialCriteria`.
    Moreover, fetchData() is also an example of a ListGrid API that doesn't apply to menu, and, as was done for setCriteria() and other APIs like setCriteria().

    Specified by:
      `setDataSource` in interface `DataBoundComponent`
    Overrides:
      `setDataSource` in class `ListGrid`
    Parameters:
      `dataSource` - New dataSource value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `DataBinding`
      - DataSource fields Example

  - ### getDataSourceAsString

    public String getDataSourceAsString()
    Optional DataSource to fetch menuItems and submenus from, instead of using `items`. May be specified as a DataSource instance or the String ID of a DataSource.

    Data is tree-based in menus, so the provided DataSource should be set up for hierarchical fetching - see the `Tree Data Binding overview`.

    Note that, although Menu is a subclass of `ListGrid`, some APIs, like `setCriteria` and `autoFetchData` are not supported in menus. If a dataSource is supplied, it is automatically fetched against as required, without the need for autoFetchData. To apply criteria to the fetches made in this way, see `initialCriteria`.
    Moreover, fetchData() is also an example of a ListGrid API that doesn't apply to menu, and, as was done for setCriteria() and other APIs like setCriteria().

    Returns:
      Current dataSource value. Default value is null

  - ### setDefaultWidth

    public Menu setDefaultWidth(int defaultWidth)
    The default menu width.
    Overrides:
      `setDefaultWidth` in class `Canvas`
    Parameters:
      `defaultWidth` - New defaultWidth value. Default value is 150
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `Sizing overview and related methods`

  - ### getDefaultWidth

    public int getDefaultWidth()
    The default menu width.
    Overrides:
      `getDefaultWidth` in class `Canvas`
    Returns:
      Current defaultWidth value. Default value is 150
    See Also:
      - `Sizing overview and related methods`

  - ### setEditProxyConstructor

    public Menu setEditProxyConstructor(String editProxyConstructor) throws IllegalStateException
    Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    Overrides:
      `setEditProxyConstructor` in class `ListGrid`
    Parameters:
      `editProxyConstructor` - New editProxyConstructor value. Default value is "MenuEditProxy"
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCClassName`

  - ### getEditProxyConstructor

    public String getEditProxyConstructor()
    Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    Overrides:
      `getEditProxyConstructor` in class `ListGrid`
    Returns:
      Current editProxyConstructor value. Default value is "MenuEditProxy"
    See Also:
      - `SCClassName`

  - ### setEmptyMessage

    public Menu setEmptyMessage(String emptyMessage)
    Message to show when a menu is shown with no items.

    Note : This is an advanced setting

    Overrides:
      `setEmptyMessage` in class `ListGrid`
    Parameters:
      `emptyMessage` - New emptyMessage value. Default value is "[Empty menu]"
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `HTMLString`

  - ### getEmptyMessage

    public String getEmptyMessage()
    Message to show when a menu is shown with no items.
    Overrides:
      `getEmptyMessage` in class `ListGrid`
    Returns:
      Current emptyMessage value. Default value is "[Empty menu]"
    See Also:
      - `HTMLString`

  - ### setFetchSubmenus

    public Menu setFetchSubmenus(Boolean fetchSubmenus) throws IllegalStateException
    When using a Tree or hierarchical DataSource as the menu's data, submenus are automatically generated from child nodes. `fetchSubmenus` can be set to false to disable this for the whole menu, or can be set false on a per-item basis via `MenuItem.fetchSubmenus`.
    Parameters:
      `fetchSubmenus` - New fetchSubmenus value. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getFetchSubmenus

    public Boolean getFetchSubmenus()
    When using a Tree or hierarchical DataSource as the menu's data, submenus are automatically generated from child nodes. `fetchSubmenus` can be set to false to disable this for the whole menu, or can be set false on a per-item basis via `MenuItem.fetchSubmenus`.
    Returns:
      Current fetchSubmenus value. Default value is true

  - ### setFillSpaceStyleName

    public Menu setFillSpaceStyleName(String fillSpaceStyleName) throws IllegalStateException
    If set, alternative body style for the menu used when there is no icon field and the `placement` settings indicate the menu will be filling a portion of the screen or a panel. Generally this alternative style should not have rounded or excessively large edges. If unset, then `bodyStyleName` is used instead.

    When there is an icon field, `iconFillSpaceStyleName`, if set, overrides this setting.

    Parameters:
      `fillSpaceStyleName` - New fillSpaceStyleName value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### getFillSpaceStyleName

    public String getFillSpaceStyleName()
    If set, alternative body style for the menu used when there is no icon field and the `placement` settings indicate the menu will be filling a portion of the screen or a panel. Generally this alternative style should not have rounded or excessively large edges. If unset, then `bodyStyleName` is used instead.

    When there is an icon field, `iconFillSpaceStyleName`, if set, overrides this setting.

    Returns:
      Current fillSpaceStyleName value. Default value is null
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### setFilterHiddenItems

    public Menu setFilterHiddenItems(Boolean filterHiddenItems) throws IllegalStateException
    Does this hide menu items marked as `hidden menu items` by filtering them out of the data set?

    In order to support hiding items marked as hidden, if any items are hidden or marked with `visibleWhen rules`, Menus convert the specified `array of items` to a `FilteredList` with criteria set to filter out items marked with the `itemHiddenProperty`.

    Note that this means for `filterHiddenItems:true` menus, developers wishing to interact with the menu data set must use List APIs such as `menu.getData().getLength()` and `menu.getData().get(index)`, rather than accessing simple array attributes such as `menu.getData().length` or `menu.getData()[index]`

    To get the full specified data set as an array, including hidden items, use `getAllItems()`.

    Note : This is an advanced setting

    Parameters:
      `filterHiddenItems` - New filterHiddenItems value. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getFilterHiddenItems

    public Boolean getFilterHiddenItems()
    Does this hide menu items marked as `hidden menu items` by filtering them out of the data set?

    In order to support hiding items marked as hidden, if any items are hidden or marked with `visibleWhen rules`, Menus convert the specified `array of items` to a `FilteredList` with criteria set to filter out items marked with the `itemHiddenProperty`.

    Note that this means for `filterHiddenItems:true` menus, developers wishing to interact with the menu data set must use List APIs such as `menu.getData().getLength()` and `menu.getData().get(index)`, rather than accessing simple array attributes such as `menu.getData().length` or `menu.getData()[index]`

    To get the full specified data set as an array, including hidden items, use `getAllItems()`.

    Returns:
      Current filterHiddenItems value. Default value is true

  - ### setIconBodyStyleName

    public Menu setIconBodyStyleName(String iconBodyStyleName) throws IllegalStateException
    If set, the CSS style used for the body of this menu when there is an icon field. In RTL mode, the `iconBodyStyleName` is suffixed with "RTL", which allows skins to apply different styles in LTR and RTL modes.

    Note: Any skin which uses `iconBodyStyleName` should add "RTL" styles as well, even if identical to LTR styles. Otherwise, menus may lose their styling in RTL mode.

    Parameters:
      `iconBodyStyleName` - New iconBodyStyleName value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `setIconFillSpaceStyleName(java.lang.String)`
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### getIconBodyStyleName

    public String getIconBodyStyleName()
    If set, the CSS style used for the body of this menu when there is an icon field. In RTL mode, the `iconBodyStyleName` is suffixed with "RTL", which allows skins to apply different styles in LTR and RTL modes.

    Note: Any skin which uses `iconBodyStyleName` should add "RTL" styles as well, even if identical to LTR styles. Otherwise, menus may lose their styling in RTL mode.

    Returns:
      Current iconBodyStyleName value. Default value is null
    See Also:
      - `getIconFillSpaceStyleName()`
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### setIconFieldProperties

    public Menu setIconFieldProperties(ListGridField iconFieldProperties) throws IllegalStateException
    Custom properties for the automatically generated icon column.

    See `showIcons` for an overview of the icon column.

    Parameters:
      `iconFieldProperties` - New iconFieldProperties value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getIconFieldProperties

    public ListGridField getIconFieldProperties()
    Custom properties for the automatically generated icon column.

    See `showIcons` for an overview of the icon column.

    Returns:
      Current iconFieldProperties value. Default value is null

  - ### setIconFillSpaceStyleName

    public Menu setIconFillSpaceStyleName(String iconFillSpaceStyleName) throws IllegalStateException
    If set, alternative body style for the menu used when there is an icon field and the `placement` settings indicate the menu will be filling a portion of the screen or a panel. Generally this alternative style should not have rounded or excessively large edges. In RTL mode, the `iconFillSpaceStyleName` is suffixed with "RTL", which allows skins to apply different styles in LTR and RTL modes. If unset, then `iconBodyStyleName` is used instead.

    Note: Like `iconBodyStyleName`, any skin which uses `iconFillSpaceStyleName` should add "RTL" styles as well, even if identical to LTR styles. Otherwise, menus may lose their styling in RTL mode.

    Parameters:
      `iconFillSpaceStyleName` - New iconFillSpaceStyleName value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### getIconFillSpaceStyleName

    public String getIconFillSpaceStyleName()
    If set, alternative body style for the menu used when there is an icon field and the `placement` settings indicate the menu will be filling a portion of the screen or a panel. Generally this alternative style should not have rounded or excessively large edges. In RTL mode, the `iconFillSpaceStyleName` is suffixed with "RTL", which allows skins to apply different styles in LTR and RTL modes. If unset, then `iconBodyStyleName` is used instead.

    Note: Like `iconBodyStyleName`, any skin which uses `iconFillSpaceStyleName` should add "RTL" styles as well, even if identical to LTR styles. Otherwise, menus may lose their styling in RTL mode.

    Returns:
      Current iconFillSpaceStyleName value. Default value is null
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### setIconHeight

    public Menu setIconHeight(int iconHeight)
    The default height applied to custom icons in this menu. This is used whenever item.iconHeight is not specified.
    Parameters:
      `iconHeight` - New iconHeight value. Default value is 16
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getIconHeight

    public int getIconHeight()
    The default height applied to custom icons in this menu. This is used whenever item.iconHeight is not specified.
    Returns:
      Current iconHeight value. Default value is 16

  - ### setIconWidth

    public Menu setIconWidth(int iconWidth)
    The default width applied to custom icons in this menu. This is used whenever item.iconWidth is not specified.
    Parameters:
      `iconWidth` - New iconWidth value. Default value is 16
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getIconWidth

    public int getIconWidth()
    The default width applied to custom icons in this menu. This is used whenever item.iconWidth is not specified.
    Returns:
      Current iconWidth value. Default value is 16

  - ### setInitialCriteria

    public Menu setInitialCriteria(Criteria initialCriteria) throws IllegalStateException
    Criteria to be used when fetching items for this Menu. Note that `setCriteria` is not supported in Menus.
    Specified by:
      `setInitialCriteria` in interface `DataBoundComponent`
    Overrides:
      `setInitialCriteria` in class `ListGrid`
    Parameters:
      `initialCriteria` - New initialCriteria value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `DataBinding`

  - ### getInitialCriteria

    public Criteria getInitialCriteria()
    Criteria to be used when fetching items for this Menu. Note that `setCriteria` is not supported in Menus.
    Specified by:
      `getInitialCriteria` in interface `DataBoundComponent`
    Overrides:
      `getInitialCriteria` in class `ListGrid`
    Returns:
      Current initialCriteria value. Default value is null
    See Also:
      - `DataBinding`

  - ### setItemHiddenProperty

    public Menu setItemHiddenProperty(String itemHiddenProperty)
    Items with this property set to true will be hidden within the menu.

    Note : This is an advanced setting

    Parameters:
      `itemHiddenProperty` - New itemHiddenProperty value. Default value is "hidden"
    Returns:
      `Menu` instance, for chaining setter calls
    See Also:
      - `setFilterHiddenItems(java.lang.Boolean)`

  - ### getItemHiddenProperty

    public String getItemHiddenProperty()
    Items with this property set to true will be hidden within the menu.
    Returns:
      Current itemHiddenProperty value. Default value is "hidden"
    See Also:
      - `getFilterHiddenItems()`

  - ### setItems

    public Menu setItems(MenuItem... items)
    Synonym for `data`
    If this method is called after the component has been drawn/initialized: Synonym for `setData()`.
    Parameters:
      `items` - new items for this menu. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls

  - ### setKeyFieldProperties

    public Menu setKeyFieldProperties(ListGridField keyFieldProperties) throws IllegalStateException
    Custom properties for the automatically generated key column.

    See `showKeys` for an overview of the key column.

    Parameters:
      `keyFieldProperties` - New keyFieldProperties value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getKeyFieldProperties

    public ListGridField getKeyFieldProperties()
    Custom properties for the automatically generated key column.

    See `showKeys` for an overview of the key column.

    Returns:
      Current keyFieldProperties value. Default value is null

  - ### setMenuButtonWidth

    public Menu setMenuButtonWidth(Integer menuButtonWidth) throws IllegalStateException
    For a menu that has a `MenuButton` generated for it automatically (for example when included in a `MenuBar`, the width that the MenuButton should have. If unset, the MenuButton will be as wide as `menu.width`.
    Parameters:
      `menuButtonWidth` - New menuButtonWidth value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getMenuButtonWidth

    public Integer getMenuButtonWidth()
    For a menu that has a `MenuButton` generated for it automatically (for example when included in a `MenuBar`, the width that the MenuButton should have. If unset, the MenuButton will be as wide as `menu.width`.
    Returns:
      Current menuButtonWidth value. Default value is null

  - ### getNavigationBar

    public NavigationBar getNavigationBar() throws IllegalStateException
    Navigation bar shown when `placement` setting indicates that the menu should be shown filling a portion of the screen or a panel.

    This component is an AutoChild named "navigationBar". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current navigationBar value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### getNavStack

    public Canvas getNavStack() throws IllegalStateException
    When the `placement` setting indicates that the menu should be shown filling a portion of the screen or a panel, `navStack` is a container element created to hold the `NavigationBar` and any submenus that are shown by the menu.

    This component is an AutoChild named "navStack". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current navStack value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setPlacement

    public Menu setPlacement(PanelPlacement placement) throws IllegalStateException
    Where should the menu be placed on the screen?

    Default is to use `PanelPlacement` "fillScreen" if `isHandset`. In any non-handset device, `placement` is unset, so the menu defaults to normal placement (near the originating MenuButton, or the mouse for a context menu, or according to left/top/width/height for a manually created Menu).

    When using any `placement` setting that fills a portion of the screen or a panel, submenus are displayed by sliding them into place on top of the currently active menu, and a `menu.navigationBar` is used to manage navigation to the main menu (and provide dismissal, via a `cancel button`.

    Parameters:
      `placement` - New placement value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getPlacement

    public PanelPlacement getPlacement()
    Where should the menu be placed on the screen?

    Default is to use `PanelPlacement` "fillScreen" if `isHandset`. In any non-handset device, `placement` is unset, so the menu defaults to normal placement (near the originating MenuButton, or the mouse for a context menu, or according to left/top/width/height for a manually created Menu).

    When using any `placement` setting that fills a portion of the screen or a panel, submenus are displayed by sliding them into place on top of the currently active menu, and a `menu.navigationBar` is used to manage navigation to the main menu (and provide dismissal, via a `cancel button`.

    Returns:
      Current placement value. Default value is null

  - ### setShowAnimationEffect

    public Menu setShowAnimationEffect(String showAnimationEffect)
    When this menu is shown how should it animate into view? By default the menu will just show at the specified size/position. Options for animated show effects are `"fade"` to fade from transparent to visible, `"slide"` to slide the menu into view, or `"wipe"` to have the menu grow into view, revealing its content as it grows. Can be overridden by passing the 'animationEffect' parameter to 'menu.show()'

    Note : This is an advanced setting

    Parameters:
      `showAnimationEffect` - New showAnimationEffect value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getShowAnimationEffect

    public String getShowAnimationEffect()
    When this menu is shown how should it animate into view? By default the menu will just show at the specified size/position. Options for animated show effects are `"fade"` to fade from transparent to visible, `"slide"` to slide the menu into view, or `"wipe"` to have the menu grow into view, revealing its content as it grows. Can be overridden by passing the 'animationEffect' parameter to 'menu.show()'
    Returns:
      Current showAnimationEffect value. Default value is null

  - ### setShowEdges

    public Menu setShowEdges(Boolean showEdges) throws IllegalStateException
    `showEdges` dynamically defaults to false when the `placement` setting indicates the Menu will be filling a portion of the screen or a panel.
    Overrides:
      `setShowEdges` in class `Canvas`
    Parameters:
      `showEdges` - New showEdges value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - Edges Example

  - ### getShowEdges

    public Boolean getShowEdges()
    `showEdges` dynamically defaults to false when the `placement` setting indicates the Menu will be filling a portion of the screen or a panel.
    Overrides:
      `getShowEdges` in class `Canvas`
    Returns:
      Current showEdges value. Default value is null
    See Also:
      - Edges Example

  - ### setShowIcons

    public Menu setShowIcons(Boolean showIcons)
    A boolean, indicating whether the checkmark/custom icon column should be displayed.
    If this method is called after the component has been drawn/initialized: Show or hide the checkmark/custom icon column at runtime.
    Parameters:
      `showIcons` - whether the icon column should be displayed. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getShowIcons

    public Boolean getShowIcons()
    A boolean, indicating whether the checkmark/custom icon column should be displayed.
    Returns:
      Current showIcons value. Default value is true

  - ### setShowKeys

    public Menu setShowKeys(Boolean showKeys)
    A boolean, indicating whether the shortcut key column should be displayed. If showKeys is not set, the menu will show the key column only if one of its items specifies a keys property. If showKeys is false, the keys will not be displayed, but will still function.
    Parameters:
      `showKeys` - New showKeys value. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getShowKeys

    public Boolean getShowKeys()
    A boolean, indicating whether the shortcut key column should be displayed. If showKeys is not set, the menu will show the key column only if one of its items specifies a keys property. If showKeys is false, the keys will not be displayed, but will still function.
    Returns:
      Current showKeys value. Default value is true

  - ### setShowShadow

    public Menu setShowShadow(Boolean showShadow) throws IllegalStateException
    Whether to show a drop shadow for this Canvas.

    Developers should be aware that the drop shadow is drawn outside the specified width and height of the widget meaning a widget with shadows takes up a little more space than it otherwise would. A full screen canvas with showShadow set to true as this would be likely to cause browser scrollbars to appear - developers can handle this by either setting this property to false on full-screen widgets, or by setting overflow to "hidden" on the <body> element browser-level scrolling is never intended to occur.

    `showShadow` dynamically defaults to false when the `placement` setting indicates the Menu will be filling a portion of the screen or a panel.

    Overrides:
      `setShowShadow` in class `Canvas`
    Parameters:
      `showShadow` - New showShadow value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - Shadows Example

  - ### getShowShadow

    public Boolean getShowShadow()
    Whether to show a drop shadow for this Canvas.

    Developers should be aware that the drop shadow is drawn outside the specified width and height of the widget meaning a widget with shadows takes up a little more space than it otherwise would. A full screen canvas with showShadow set to true as this would be likely to cause browser scrollbars to appear - developers can handle this by either setting this property to false on full-screen widgets, or by setting overflow to "hidden" on the <body> element browser-level scrolling is never intended to occur.

    `showShadow` dynamically defaults to false when the `placement` setting indicates the Menu will be filling a portion of the screen or a panel.

    Overrides:
      `getShowShadow` in class `Canvas`
    Returns:
      Current showShadow value. Default value is null
    See Also:
      - Shadows Example

  - ### setShowSubmenus

    public Menu setShowSubmenus(Boolean showSubmenus)
    A boolean, indicating whether the submenu indicator column should be displayed. If showSubmenus is not set, the menu will show the indicator column only if one of its items specifies a submenu property. If showSubmenus is false, the submenu arrows will not be displayed, but submenus will still appear on rollover.
    If this method is called after the component has been drawn/initialized: Show or hide the submenu indicator column at runtime.
    Parameters:
      `showSubmenus` - whether the submenu indicator column should be displayed. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getShowSubmenus

    public Boolean getShowSubmenus()
    A boolean, indicating whether the submenu indicator column should be displayed. If showSubmenus is not set, the menu will show the indicator column only if one of its items specifies a submenu property. If showSubmenus is false, the submenu arrows will not be displayed, but submenus will still appear on rollover.
    Returns:
      Current showSubmenus value. Default value is true

  - ### setSubmenuConstructor

    public Menu setSubmenuConstructor(String submenuConstructor) throws IllegalStateException
    When using a Tree or hierarchical DataSource as the menu's data, optional subclass of Menu that should be used when generating submenus.
    Parameters:
      `submenuConstructor` - New submenuConstructor value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCClassName`

  - ### getSubmenuConstructor

    public String getSubmenuConstructor()
    When using a Tree or hierarchical DataSource as the menu's data, optional subclass of Menu that should be used when generating submenus.
    Returns:
      Current submenuConstructor value. Default value is null
    See Also:
      - `SCClassName`

  - ### setSubmenuDirection

    public Menu setSubmenuDirection(String submenuDirection)
    Should submenus show up on our left or right. Can validly be set to `"left"` or `"right"`. If unset, submenus show up on the right by default in Left-to-right text mode, or on the left in Right-to-left text mode (see `Page.isRTL()`).
    Parameters:
      `submenuDirection` - New submenuDirection value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getSubmenuDirection

    public String getSubmenuDirection()
    Should submenus show up on our left or right. Can validly be set to `"left"` or `"right"`. If unset, submenus show up on the right by default in Left-to-right text mode, or on the left in Right-to-left text mode (see `Page.isRTL()`).
    Returns:
      Current submenuDirection value. Default value is null

  - ### setSubmenuDisabledImage

    public Menu setSubmenuDisabledImage(String submenuDisabledImage) throws IllegalStateException
    Default image to use for the submenu indicator when the item is disabled. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.

    If `submenuDirection` is set to `"left"`, the image src will have the suffix `"_left"` appended to it.

    Parameters:
      `submenuDisabledImage` - New submenuDisabledImage value. Default value is {...}
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getSubmenuDisabledImage

    public String getSubmenuDisabledImage()
    Default image to use for the submenu indicator when the item is disabled. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.

    If `submenuDirection` is set to `"left"`, the image src will have the suffix `"_left"` appended to it.

    Returns:
      Current submenuDisabledImage value. Default value is {...}
    See Also:
      - `SCImgURL`

  - ### setSubmenuDisabledImage

    public Menu setSubmenuDisabledImage(ImgHTMLProperties submenuDisabledImage) throws IllegalStateException
    Default image to use for the submenu indicator when the item is disabled. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.

    If `submenuDirection` is set to `"left"`, the image src will have the suffix `"_left"` appended to it.

    Parameters:
      `submenuDisabledImage` - New submenuDisabledImage value. Default value is {...}
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getSubmenuDisabledImageAsImgHTMLProperties

    public ImgHTMLProperties getSubmenuDisabledImageAsImgHTMLProperties()
    Default image to use for the submenu indicator when the item is disabled. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.

    If `submenuDirection` is set to `"left"`, the image src will have the suffix `"_left"` appended to it.

    Returns:
      Current submenuDisabledImage value. Default value is {...}
    See Also:
      - `SCImgURL`

  - ### setSubmenuFieldProperties

    public Menu setSubmenuFieldProperties(ListGridField submenuFieldProperties) throws IllegalStateException
    Custom properties for the automatically generated submenu column.

    See `showSubmenus` for an overview of the submenu column.

    Parameters:
      `submenuFieldProperties` - New submenuFieldProperties value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSubmenuFieldProperties

    public ListGridField getSubmenuFieldProperties()
    Custom properties for the automatically generated submenu column.

    See `showSubmenus` for an overview of the submenu column.

    Returns:
      Current submenuFieldProperties value. Default value is null

  - ### setSubmenuImage

    public Menu setSubmenuImage(String submenuImage) throws IllegalStateException
    Default image to use for the submenu indicator. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.

    If `submenuDirection` is set to `"left"`, the image src will have the suffix `"_left"` appended to it.

    Parameters:
      `submenuImage` - New submenuImage value. Default value is {...}
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getSubmenuImage

    public String getSubmenuImage()
    Default image to use for the submenu indicator. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.

    If `submenuDirection` is set to `"left"`, the image src will have the suffix `"_left"` appended to it.

    Returns:
      Current submenuImage value. Default value is {...}
    See Also:
      - `SCImgURL`

  - ### setSubmenuImage

    public Menu setSubmenuImage(ImgHTMLProperties submenuImage) throws IllegalStateException
    Default image to use for the submenu indicator. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.

    If `submenuDirection` is set to `"left"`, the image src will have the suffix `"_left"` appended to it.

    Parameters:
      `submenuImage` - New submenuImage value. Default value is {...}
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getSubmenuImageAsImgHTMLProperties

    public ImgHTMLProperties getSubmenuImageAsImgHTMLProperties()
    Default image to use for the submenu indicator. The value can be either a regular `SCImgURL` which can specify size:w,h;, or an `ImgHTMLProperties` object, specifying at least src, width and height.

    If `submenuDirection` is set to `"left"`, the image src will have the suffix `"_left"` appended to it.

    Returns:
      Current submenuImage value. Default value is {...}
    See Also:
      - `SCImgURL`

  - ### setTarget

    public Menu setTarget(Canvas target)
    Optional target canvas for this menu. Available as a parameter to dynamic menuItem configuration methods such as `MenuItem.checkIf()`.

    Whenever a Menu is shown as a contextMenu by a widget due to `Canvas.contextMenu` being set, `menu.target` is automatically set to the widget that showed the contextMenu.

    If this item has any `submenus` the `target` will be propagated down to these child menus.

    Parameters:
      `target` - New target value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getTarget

    public Canvas getTarget()
    Optional target canvas for this menu. Available as a parameter to dynamic menuItem configuration methods such as `MenuItem.checkIf()`.

    Whenever a Menu is shown as a contextMenu by a widget due to `Canvas.contextMenu` being set, `menu.target` is automatically set to the widget that showed the contextMenu.

    If this item has any `submenus` the `target` will be propagated down to these child menus.

    Returns:
      Current target value. Default value is null

  - ### setTitleFieldProperties

    public Menu setTitleFieldProperties(ListGridField titleFieldProperties) throws IllegalStateException
    Custom properties for the automatically generated title column.
    Parameters:
      `titleFieldProperties` - New titleFieldProperties value. Default value is null
    Returns:
      `Menu` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getTitleFieldProperties

    public ListGridField getTitleFieldProperties()
    Custom properties for the automatically generated title column.
    Returns:
      Current titleFieldProperties value. Default value is null

  - ### setUseKeys

    public Menu setUseKeys(Boolean useKeys)
    A boolean indicating whether this menu should use shortcut keys. Set useKeys to false in a menu's initialization block to explicitly disable shortcut keys.
    Parameters:
      `useKeys` - New useKeys value. Default value is true
    Returns:
      `Menu` instance, for chaining setter calls

  - ### getUseKeys

    public Boolean getUseKeys()
    A boolean indicating whether this menu should use shortcut keys. Set useKeys to false in a menu's initialization block to explicitly disable shortcut keys.
    Returns:
      Current useKeys value. Default value is true

  - ### fetchData

    public void fetchData()
    This DataBoundComponent method does not apply to Menu.
    Specified by:
      `fetchData` in interface `DataBoundComponent`
    Overrides:
      `fetchData` in class `ListGrid`

  - ### fetchData

    public void fetchData(Criteria criteria)
    See `fetchData()`
    Specified by:
      `fetchData` in interface `DataBoundComponent`
    Overrides:
      `fetchData` in class `ListGrid`
    Parameters:
      `criteria` - Search criteria. If a `DynamicForm` is passed in as this argument instead of a raw criteria object, will be derived by calling `DynamicForm.getValuesAsCriteria()`

  - ### fetchData

    public void fetchData(Criteria criteria, DSCallback callback)
    See `fetchData()`
    Specified by:
      `fetchData` in interface `DataBoundComponent`
    Overrides:
      `fetchData` in class `ListGrid`
    Parameters:
      `criteria` - Search criteria. If a `DynamicForm` is passed in as this argument instead of a raw criteria object, will be derived by calling `DynamicForm.getValuesAsCriteria()`
      `callback` - callback to invoke when a fetch is complete. Fires only if server contact was required

  - ### fetchData

    public void fetchData(Criteria criteria, DSCallback callback, DSRequest requestProperties)
    This DataBoundComponent method does not apply to Menu.
    Specified by:
      `fetchData` in interface `DataBoundComponent`
    Overrides:
      `fetchData` in class `ListGrid`
    Parameters:
      `criteria` - Search criteria. If a `DynamicForm` is passed in as this argument instead of a raw criteria object, will be derived by calling `DynamicForm.getValuesAsCriteria()`
      `callback` - callback to invoke when a fetch is complete. Fires only if server contact was required
      `requestProperties` - additional properties to set on the DSRequest that will be issued

  - ### getAllItems

    public MenuItem[] getAllItems()
    Retrieves the full set of items for this menu, including `hidden items`
    Returns:

  - ### getCellStyle

    public String getCellStyle(ListGridRecord record, int rowNum, int colNum)
    Return the CSS class for a cell. By default this method has the following implementation:
    - return any custom style for the record (`GridRenderer.recordCustomStyleProperty`) if defined.
    - create a style name based on the result of `GridRenderer.getBaseStyle()` and the state of the record using the rules described in `CellStyleSuffixes`.

    Cell Styles are customizable by:

    - attaching a custom style to a record by setting `record[this.recordCustomStyleProperty]` to some valid CSS style name.
    - modifying the base style returned by getBaseStyle() [see that method for further documentation on this]
    - overriding this function

    In addition to this, `getCellCSSText()` may be overriden to provide custom cssText to apply on top of the styling attributes derived from the named style.

    Note: This is an override point.

    Overrides:
      `getCellStyle` in class `ListGrid`
    Parameters:
      `record` - record object for this row and column
      `rowNum` - number of the row
      `colNum` - number of the column
    Returns:
      CSS style for this cell. See `CSSStyleName`
    See Also:
      - `Appearance overview and related methods`

  - ### getItem

    public MenuItem getItem(int item)
    Get a particular MenuItem by index. Note that by default the index passed in is interpreted as the position within currently visible set of items for the menu, not including hidden items.

    To look up an item based on its position in the full set of `specified items`, including those that are not visible, pass in the `logicalIndex` parameter.

    If passed a MenuItem, returns it.

    Parameters:
      `item` - index of the MenuItem
    Returns:
      the MenuItem, Pointer to the item, or null if not defined

  - ### getItem

    public MenuItem getItem(int item, boolean logicalIndex)
    Get a particular MenuItem by index. Note that by default the index passed in is interpreted as the position within currently visible set of items for the menu, not including hidden items.

    To look up an item based on its position in the full set of `specified items`, including those that are not visible, pass in the `logicalIndex` parameter.

    If passed a MenuItem, returns it.

    Parameters:
      `item` - index of the MenuItem
      `logicalIndex` - Interpret the index passed in with regards to the full set of specified items.
    Returns:
      the MenuItem, Pointer to the item, or null if not defined

  - ### getVisibleItemNum

    public int getVisibleItemNum(MenuItem item)
    Given a MenuItem, return its index in the currently visible set of items.

    To get the index of the item in the `full set of items`, including `hidden items`, use `getItemNum()` instead

    Parameters:
      `item` - Menu Item to find
    Returns:
      index of the item in the visible items, or -1 if not found.
    See Also:
      - `getFilterHiddenItems()`

  - ### hideContextMenu

    public void hideContextMenu()
    Hide the context menu - alias for hide()
    Overrides:
      `hideContextMenu` in class `Canvas`
    See Also:
      - `Visibility overview and related methods`

  - ### addItemClickHandler

    public HandlerRegistration addItemClickHandler(ItemClickHandler handler)
    Add a itemClick handler.

    Executed when a menu item with no click handler is clicked by the user. This itemClick handler must be specified as a function. It is passed an item parameter that is a reference to the clicked menu item.

    Specified by:
      `addItemClickHandler` in interface `HasItemClickHandlers`
    Parameters:
      `handler` - the itemClick handler
    Returns:
      `HandlerRegistration` used to remove this handler

  - ### setCriteria

    public void setCriteria(Criteria criteria)
    This DataBoundComponent method is not supported - use `initialCriteria` to apply criteria to the fetches made by menus.
    Overrides:
      `setCriteria` in class `ListGrid`
    Parameters:
      `criteria` - new criteria to show

  - ### setCriteria

    public void setCriteria(AdvancedCriteria criteria)
    This DataBoundComponent method is not supported - use `initialCriteria` to apply criteria to the fetches made by menus.
    Parameters:
      `criteria` - new criteria to show

  - ### setItemHidden

    public boolean setItemHidden(MenuItem item)
    Hides or shows the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the hidden state.
    Parameters:
      `item` - MenuItem in question, or its index. Note that if an index is passed it will be interpreted as the index in the full specified set of items rather than the visible-index of the item.
    Returns:
      true if the hidden state was changed
    See Also:
      - `getFilterHiddenItems()`

  - ### setItemHidden

    public boolean setItemHidden(int item)
    Hides or shows the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the hidden state.
    Parameters:
      `item` - MenuItem in question, or its index. Note that if an index is passed it will be interpreted as the index in the full specified set of items rather than the visible-index of the item.
    Returns:
      true if the hidden state was changed
    See Also:
      - `getFilterHiddenItems()`

  - ### setItemHidden

    public boolean setItemHidden(MenuItem item, boolean newState)
    Hides or shows the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the hidden state.
    Parameters:
      `item` - MenuItem in question, or its index. Note that if an index is passed it will be interpreted as the index in the full specified set of items rather than the visible-index of the item.
      `newState` - true to hide the menu item, false to show it.
    Returns:
      true if the hidden state was changed
    See Also:
      - `getFilterHiddenItems()`

  - ### setItemHidden

    public boolean setItemHidden(int item, boolean newState)
    Hides or shows the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the hidden state.
    Parameters:
      `item` - MenuItem in question, or its index. Note that if an index is passed it will be interpreted as the index in the full specified set of items rather than the visible-index of the item.
      `newState` - true to hide the menu item, false to show it.
    Returns:
      true if the hidden state was changed
    See Also:
      - `getFilterHiddenItems()`

  - ### showContextMenu

    public Boolean showContextMenu()
    Show this menu as a context menu, that is, immediately adjacent to the current mouse position.
    Returns:
      false == stop processing this event
    See Also:
      - `Visibility overview and related methods`

  - ### hideAllMenus

    public static void hideAllMenus()
    Hide all menus that are currently open. This method is useful to hide the current set of menus including submenus, and dismiss the menu's clickMask.

  - ### setDefaultProperties

    public static void setDefaultProperties(Menu menuProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `menuProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### onInit_ListGrid

    protected void onInit_ListGrid()
    Overrides:
      `onInit_ListGrid` in class `ListGrid`

  - ### getSubmenu

    public Menu getSubmenu(MenuItem item)
    Creates and returns the submenu associated with the provided MenuItem.
    Parameters:
      `menuItem` - to target
    Returns:
      submenu for that menuItem
    See Also:
      - Appearance Example

  - ### setDataProperties

    public void setDataProperties(Tree dataProperties) throws IllegalStateException
    For a `Menu` that uses a DataSource, these properties will be passed to the automatically-created ResultTree. This can be used for various customizations such as modifying the automatically-chosen `parentIdField`.
    Parameters:
      `dataProperties` - dataProperties Default value is null
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `Databinding overview and related methods`

  - ### getItems

    public MenuItem[] getItems()
    Return the menu items.
    Returns:
      the menu items

  - ### setTitle

    public void setTitle(String title)
    When used in a MenuBar, the title of the menu button create will be the title of the Menu.
    Overrides:
      `setTitle` in class `Canvas`
    Parameters:
      `title` - the title

  - ### removeItem

    public void removeItem(MenuItem item)

  - ### addItem

    public void addItem(MenuItem item)

  - ### addItem

    public void addItem(MenuItem item, int index)

  - ### getItemNum

    public int getItemNum(MenuItem item)
    Given a MenuItem, return it's index in the items array.
    Parameters:
      `item` - the MenuItem
    Returns:
      index of the item, or -1 if not defined.

  - ### setItemProperties

    public void setItemProperties(int item, MenuItem properties)
    Set arbitrary properties for a particular menu item.
    Parameters:
      `item` - MenuItem or visible index of the MenuItem
      `properties` - properties to apply to the item

  - ### setItemChecked

    public Boolean setItemChecked(MenuItem item)
    Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the checked state.
    Parameters:
      `item` - MenuItem in question, or it's index
    Returns:
      true if the checked state was changed

  - ### setItemChecked

    public Boolean setItemChecked(int item)
    Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the checked state.
    Parameters:
      `item` - MenuItem in question, or it's index
    Returns:
      true if the checked state was changed

  - ### setItemChecked

    public Boolean setItemChecked(MenuItem item, boolean newState)
    Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the checked state.
    Parameters:
      `item` - MenuItem in question, or it's index
      `newState` - true to check the menu item, false to uncheck it. If not passed, true is assumed
    Returns:
      true if the checked state was changed

  - ### setItemChecked

    public Boolean setItemChecked(int item, boolean newState)
    Checks or unchecks the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the checked state.
    Parameters:
      `item` - MenuItem in question, or it's index
      `newState` - true to check the menu item, false to uncheck it. If not passed, true is assumed
    Returns:
      true if the checked state was changed

  - ### setItemEnabled

    public Boolean setItemEnabled(MenuItem item)
    Enables or disables the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the enabled state.
    Parameters:
      `item` - MenuItem in question, or it's index
    Returns:
      true if the enabled state was changed

  - ### setItemEnabled

    public Boolean setItemEnabled(int item)
    Enables or disables the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the enabled state.
    Parameters:
      `item` - MenuItem in question, or it's index
    Returns:
      true if the enabled state was changed

  - ### setItemEnabled

    public Boolean setItemEnabled(MenuItem item, boolean newState)
    Enables or disables the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the enabled state.
    Parameters:
      `item` - MenuItem in question, or it's index
      `newState` - true to enable the menu item, false to disable it. If not passed, true is assumed
    Returns:
      true if the enabled state was changed

  - ### setItemEnabled

    public Boolean setItemEnabled(int item, boolean newState)
    Enables or disables the menu item according to the value of newState, and redraws the menu if necessary. Returns true if there's a change in the enabled state.
    Parameters:
      `item` - MenuItem in question, or it's index
      `newState` - true to enable the menu item, false to disable it. If not passed, true is assumed
    Returns:
      true if the enabled state was changed

  - ### setItemIcon

    public Boolean setItemIcon(MenuItem item, String newIcon)
    Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary. Returns true if the icon changed.
    Parameters:
      `item` - MenuItem or visible index of the MenuItem
      `newIcon` - new icon URL
    Returns:
      true == something changed, redraw is called for

  - ### setItemIcon

    public Boolean setItemIcon(int item, String newIcon)
    Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary. Returns true if the icon changed.
    Parameters:
      `item` - MenuItem or visible index of the MenuItem
      `newIcon` - new icon URL
    Returns:
      true == something changed, redraw is called for

  - ### setItemIcon

    public Boolean setItemIcon(MenuItem item, String newIcon, String newDisabledIcon)
    Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary. Returns true if the icon changed.
    Parameters:
      `item` - MenuItem or visible index of the MenuItem
      `newIcon` - new icon URL
      `newDisabledIcon` - new icon URL for disabled image
    Returns:
      true == something changed, redraw is called for

  - ### setItemIcon

    public Boolean setItemIcon(int item, String newIcon, String newDisabledIcon)
    Sets the icon and disabled icon (if specified) for a particular menu item and redraws the menu if necessary. Returns true if the icon changed.
    Parameters:
      `item` - MenuItem or visible index of the MenuItem
      `newIcon` - new icon URL
      `newDisabledIcon` - new icon URL for disabled image
    Returns:
      true == something changed, redraw is called for

  - ### setItemTitle

    public Boolean setItemTitle(MenuItem item, String newTitle)
    Sets the title of a particular menu item to the string specified by newTitle and redraws the menu if necessary.
    Parameters:
      `item` - MenuItem or visible index of the MenuItem
      `newTitle` - new title
    Returns:
      true if the title was changed, and false otherwise

  - ### setItemTitle

    public Boolean setItemTitle(int item, String newTitle)
    Sets the title of a particular menu item to the string specified by newTitle and redraws the menu if necessary.
    Parameters:
      `item` - MenuItem or visible index of the MenuItem
      `newTitle` - new title
    Returns:
      true if the title was changed, and false otherwise

  - ### getOrCreateRef

    public static Menu getOrCreateRef(JavaScriptObject jsObj, MenuItem parentItem)

  - ### relinkJavaScriptObject

    public void relinkJavaScriptObject(JavaScriptObject jsObj)

  - ### getOrCreateJsObj

    public JavaScriptObject getOrCreateJsObj()
    Specified by:
      `getOrCreateJsObj` in interface `DataBoundComponent`
    Overrides:
      `getOrCreateJsObj` in class `BaseWidget`

  - ### setConfig

    public void setConfig(JavaScriptObject config)
    Overrides:
      `setConfig` in class `BaseWidget`

  - ### setIconFieldDefaults

    public static void setIconFieldDefaults(ListGridField iconFieldDefaults)
    Default properties for the automatically generated icon column. Default object includes properties to set width and to show icon for this column.

    To modify the behavior or appearance of this column, developers may set `iconFieldProperties` at the instance level, or `iconFieldDefaults` to affect all instances of the class. See `showIcons` for an overview of the icon column.

    Parameters:
      `iconFieldDefaults` -

  - ### getIconFieldDefaults

    public static ListGridField getIconFieldDefaults()
    Default properties for the automatically generated icon column. Default object includes properties to set width and to show icon for this column.

    To modify the behavior or appearance of this column, developers may set `iconFieldProperties` at the instance level, or `iconFieldDefaults` to affect all instances of the class. See `showIcons` for an overview of the icon column.

    Parameters:
      `iconFieldDefaults` - Default value is object

  - ### setKeyFieldDefaults

    public static void setKeyFieldDefaults(ListGridField keyFieldDefaults)
    Default properties for the automatically generated key column. Default object includes properties to set width and to show key for this column.

    To modify the behavior or appearance of this column, developers may set `keyFieldProperties` at the instance level, or `keyFieldDefaults` to affect all instances of the class. See `showKeys` for an overview of the key column.

    Parameters:
      `keyFieldDefaults` - Default value is object

  - ### getKeyFieldDefaults

    public static ListGridField getKeyFieldDefaults()
    Default properties for the automatically generated key column. Default object includes properties to set width and to show key for this column.

    To modify the behavior or appearance of this column, developers may set `keyFieldProperties` at the instance level, or `keyFieldDefaults` to affect all instances of the class. See `showKeys` for an overview of the key column.

    Parameters:
      `keyFieldDefaults` - Default value is object

  - ### setSubmenuFieldDefaults

    public static void setSubmenuFieldDefaults(ListGridField submenuFieldDefaults)
    Default properties for the automatically generated submenu column. Default object includes properties to set width, align and to show submenu icon for this column.

    To modify the behavior or appearance of this column, developers may set `submenuFieldProperties` at the instance level, or `submenuFieldDefaults` to affect all instances of the class. See `showSubmenus` for an overview of the submenu column.

    Parameters:
      `submenuFieldDefaults` - Default value is object

  - ### getSubmenuFieldDefaults

    public static ListGridField getSubmenuFieldDefaults()
    Default properties for the automatically generated submenu column. Default object includes properties to set width, align and to show submenu icon for this column.

    To modify the behavior or appearance of this column, developers may set `submenuFieldProperties` at the instance level, or `submenuFieldDefaults` to affect all instances of the class. See `showSubmenus` for an overview of the submenu column.

    Parameters:
      `submenuFieldDefaults` - Default value is object

  - ### setTitleFieldDefaults

    public static void setTitleFieldDefaults(ListGridField titleFieldDefaults)
    Default properties for the automatically generated title column. Default object includes properties to set width and to show title for this column.

    To modify the behavior or appearance of this column, developers may set `titleFieldProperties` at the instance level, or `titleFieldDefaults` to affect all instances of the class

    Parameters:
      `titleFieldDefaults` - Default value is object

  - ### getTitleFieldDefaults

    public static ListGridField getTitleFieldDefaults()
    Default properties for the automatically generated title column. Default object includes properties to set width and to show title for this column.

    To modify the behavior or appearance of this column, developers may set `titleFieldProperties` at the instance level, or `titleFieldDefaults` to affect all instances of the class

    Parameters:
      `titleFieldDefaults` - Default value is object

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(MenuLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `ListGrid`